<?php
namespace TecDiet\Services;

use Doctrine\ORM\EntityManager;
use TecDiet\Util\Validation;

class PatientsService implements Queries {

    protected $entityManager;
    protected $connection;
    protected $patients = array();
    
    protected $auxPatientSequential;
    protected $defaultPatientCode;
    protected $verificaRestricaoAlimentar;

    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
        $this->connection = $entityManager->getConnection();
        $this->verificaRestricaoAlimentar = $verificaRestricaoAlimentar;

    }

    private function getTotPlateService($rowDiet) {

        $sth = $this->connection->prepare(self::MP_TOT_PRATOSERV);

        $sth->execute(array(
            'P_CDDIETPAD'  => $rowDiet['CDDIETPAD'],
            'P_CDFILIAL'   => $rowDiet['CDFILIAL'],
            'P_CDPACIENTE' => $rowDiet['CDPACIENTE'],
            'P_CDSERVFILI' => $rowDiet['CDSERVFILI'],
            'P_DTINICIAL'  => $rowDiet['DTINICIAL'],
            'P_CDALA'      => $rowDiet['CDALA'],
            'P_DTFINAL'    => $rowDiet['DTFINAL'],
            'P_CDANDAR'    => $rowDiet['CDANDAR'],
            'P_CDTIPOPRAT' => $rowDiet['CDTIPOPRA'],
        ));
        
        return $sth->fetchAll(\PDO::FETCH_ASSOC);
    }
}