function ruiTimeController($scope, $element, ZhUtil, ScreenService) {

    $scope.ZhUtil = ZhUtil;

    $scope.init = function() {
        if (window.orientation)
            detectOrientationAndRotate();
        var fieldValue;
        if ($scope.fieldRow)
            fieldValue = $scope.fieldRow;
        else
            fieldValue = $scope.ZhUtil.evaluate($scope.field.defaultValue);
        if (fieldValue === undefined) {
            fieldValue = '';
        }
        else {
            var tempoArray = fieldValue.split(':'); //[0] ==  minuto [1] == hora
            clock.time.hora = parseInt(tempoArray[0]);
            clock.time.minuto = parseInt(tempoArray[1]);
            clock.hourView.children[12].style.opacity = '0';
            clock.hourView.children[clock.time.hora].style.opacity = '1';
            clock.minuteView.children[0].style.opacity = '0';
            clock.minuteView.children[clock.time.minuto].style.opacity = '1';
            timeInput.classList.add('rui-has-value');
            clock.hourWasSelected = true;
            toggleHourMode();
        }
        timeInput.children[1].textContent = fieldValue;
        $scope.fieldRow = fieldValue;
        if ($scope.field.hideOverlay) {
            overlay.style.opacity = '0';
        }
        if($scope.field.readOnly){
            timeInput.classList.add('disabled');
        }
    };

    var container = $element.get()[0];
    var clock = container.querySelector('#clock-container');
    var overlay = container.querySelector('#overlay');
    var pointerContainer = container.querySelector('#pointer-container'); /*clock.children*/
    var touchArea = container.querySelector('#touch-area');
    var timeInput = container.querySelector('#time-input');

    /* define a label */
    var label = ScreenService.i18n($scope.field.label);
    if ($scope.field.validations && $scope.field.validations.required) {
        label += " *";
    }
    timeInput.children[0].textContent = label;


    clock.minuteDisplay = container.querySelector('#red-minute');
    clock.hourInnerDisplay = container.querySelector('#red-hours-inner');
    clock.hourOutterDisplay = container.querySelector('#red-hours-outter');
    clock.pointer = pointerContainer;
    clock.HOUR_MODE = 1;
    clock.MINUTE_MODE = 2;
    clock.mode = clock.HOUR_MODE;
    clock.time = {
        hora: 12,
        minuto: 0
    };
    $scope.field.time = clock.time;
    clock.detalhesDoCirculoMinuto = {};
    clock.detalhesDoCirculoHora = {};
    clock.activeMinute = 0; /* Posicao do vetor que indica o minuto selecionado no relogio  */
    clock.activeHour = 0; /* Posicao do vetor que indica a hora selecionado no relogio  */
    clock.activeHourArrayPosition = 2; /*contém a posicao (no array de filhos de relogio, que corresponde ...)*/
    clock.hourWasSelected = false;
    clock.hourView = container.querySelector('#hour-display-container');
    clock.minuteView = container.querySelector('#minute-display-container');
    clock.okButton = container.querySelector('#ok');
    clock.cancelButton = container.querySelector('#cancel');

    clock.validate = function() {
        $scope.field.validate($scope.fieldRow);
        $scope.$apply();
    };

    var clickHander = function(e) {
        var rotationDetails = '';
        if (clock.mode == clock.MINUTE_MODE) {
            var previousMinute = clock.time.minuto;
            var minuto = getMinute(e.clientX, e.clientY, clock.detalhesDoCirculoMinuto);
            if (minuto === 60) {
                minuto = 0;
            }
            clock.time.minuto = minuto;
            rotationDetails = "rotate3d(0,0,1," + (minuto * 6) + "deg)";
            requestAnimationFrame(function() {

                pointerContainer.style.transform = rotationDetails;
                clock.minuteView.children[minuto].style.opacity = '1';
                if (previousMinute !== minuto) {
                    clock.minuteView.children[previousMinute].style.opacity = '0';
                    clock.minuteDisplay.children[clock.activeMinute].children[0].style.color = 'black';
                    if (Number.isInteger(minuto / 5)) {
                        clock.minuteDisplay.children[minuto / 5].children[0].style.color = 'white';
                        clock.activeMinute = minuto / 5;
                    }
                }
            });
        }
        else /* clock.mode = clock.HOUR_MODE*/ {
            /* se o clique for dentro do circulo interno ...*/
            var previousActiveHourArrayPosition = clock.activeHourArrayPosition;
            var hora = getHour(e.clientX, e.clientY, clock.detalhesDoCirculoHora);
            var rawHora = ((hora === 12) ? 0 : hora);
            rotationDetails = "rotate3d(0,0,1," + (hora * 30) + "deg)";
            var previousHour = clock.time.hora;
            /* se o clique for dentro do circulo interno ...*/
            if (isWithinCircumnference(clock.detalhesDoCirculoHora, {
                    x: e.clientX,
                    y: e.clientY
                })) {
                switchToInnerPointer();
                hora = ((hora) ? hora : 12);
                clock.time.hora = hora;
                clock.activeHourArrayPosition = 2;
            }
            else {
                switchToOutterPointer();
                hora = ((hora === 12 || hora === 0) ? 0 : hora + 12);
                clock.time.hora = hora;
                clock.activeHourArrayPosition = 1;
            }
            requestAnimationFrame(function() {
                pointerContainer.style.transform = rotationDetails;
                clock.hourView.children[hora].style.opacity = '1';
                if (previousHour !== hora) {
                    clock.hourView.children[previousHour].style.opacity = '0';
                    clock.children[previousActiveHourArrayPosition].
                    children[clock.activeHour].children[0].style.color = 'black';
                    //if(Number.isInteger(rawHora/5)){
                    clock.children[clock.activeHourArrayPosition].
                    children[rawHora].children[0].style.color = 'white';
                    clock.activeHour = rawHora;
                    //}
                }
            });
        }
    };




    /* se for uma tela de toque, usa o evento padrão para telas de toque*/
    if (('ontouchmove' in window) ||
        (window.navigator.MaxTouchPoints > 0) ||
        (window.navigator.msMaxTouchPoints > 0)) {

        var touchHandler = function(e) {
            //console.log('%cTOCADO','background-color: green; color: yellow');
            //e.preventDefault();
            var touch = {};
            var rotationDetails = '';
            if (clock.mode == clock.MINUTE_MODE) {
                touch = e.targetTouches[0];
                var previousMinute = clock.time.minuto;
                var minuto = getMinute(touch.pageX, touch.pageY, clock.detalhesDoCirculoMinuto);
                if (minuto === 60) {
                    minuto = 0;
                }
                clock.time.minuto = minuto;
                rotationDetails = "rotate3d(0,0,1," + (minuto * 6) + "deg)";
                requestAnimationFrame(function() {
                    pointerContainer.style.transform = rotationDetails;
                    clock.minuteView.children[minuto].style.opacity = '1';
                    if (previousMinute !== minuto) {
                        clock.minuteView.children[previousMinute].style.opacity = '0';
                        clock.minuteDisplay.children[clock.activeMinute].children[0].style.color = 'black';
                        if (Number.isInteger(minuto / 5)) {
                            clock.minuteDisplay.children[minuto / 5].children[0].style.color = 'white';
                            clock.activeMinute = minuto / 5;
                        }
                    }
                });
            }
            else /* clock.mode = clock.HOUR_MODE*/ {
                var previousActiveHourArrayPosition = clock.activeHourArrayPosition;
                touch = e.targetTouches[0];
                var hora = getHour(touch.pageX, touch.pageY, clock.detalhesDoCirculoHora);
                var rawHora = ((hora === 12) ? 0 : hora);
                rotationDetails = "rotate3d(0,0,1," + (hora * 30) + "deg)";
                var previousHour = clock.time.hora;
                /* se o clique for dentro do circulo interno ...*/
                if (isWithinCircumnference(clock.detalhesDoCirculoHora, {
                        x: touch.pageX,
                        y: touch.pageY
                    })) {
                    switchToInnerPointer();
                    hora = ((hora) ? hora : 12);
                    clock.time.hora = hora;
                    clock.activeHourArrayPosition = 2;
                }
                else {
                    switchToOutterPointer();
                    hora = ((hora === 12 || hora === 0) ? 0 : hora + 12);
                    clock.time.hora = hora;
                    clock.activeHourArrayPosition = 1;
                }
                requestAnimationFrame(function() {
                    pointerContainer.style.transform = rotationDetails;
                    clock.hourView.children[hora].style.opacity = '1';
                    if (previousHour !== hora) {
                        clock.hourView.children[previousHour].style.opacity = '0';
                        clock.children[previousActiveHourArrayPosition].
                        children[clock.activeHour].children[0].style.color = 'black';
                        //if(Number.isInteger(rawHora/5)){
                        clock.children[clock.activeHourArrayPosition].
                        children[rawHora].children[0].style.color = 'white';
                        clock.activeHour = rawHora;
                        //}
                    }
                });
            }
        };
        touchArea.ontouchmove = touchHandler;

        touchArea.ontouchend = function(e) {
            touchArea.ontouchmove = null;
            setTimeout(function() {
                touchArea.ontouchmove = touchHandler;
            }, 200);
            toggleMinuteMode();
            return true;
        };

        touchArea.ontouchstart = function(e) {
            //e.preventDefault();
            touchHandler(e);
        };
    }
    else {
        touchArea.onmousedown = function(e) {
            e.preventDefault();
            clickHander(e);
            document.addEventListener("mousemove", clickHander);
        };
        var removeListenerAndSwitchToMinutes = function(e) {
            document.removeEventListener("mousemove", clickHander);
            toggleMinuteMode();
        };
        document.addEventListener('mouseup', removeListenerAndSwitchToMinutes);
    }

    var getMinute = function( /*number*/ x, /*number*/ y,
        /*object {x: pontoX da origem, y: pontoY da origem} */
        detalhesCirculo) {
        var angleRadian = Math.atan2(y - detalhesCirculo.y, x - detalhesCirculo.x);
        var angle = angleRadian * (180 / Math.PI) + 90;
        if (angle < 0) {
            angle += 360;
        }
        return Math.round(angle / 6);
    };


    var getHour = function( /*number*/ x, /*number*/ y,
        /*object {x: pontoX da origem, y: pontoY da origem} */
        detalhesCirculo) {
        var angleRadian = Math.atan2(y - detalhesCirculo.centerPoint.y, x - detalhesCirculo.centerPoint.x);
        var angle = angleRadian * (180 / Math.PI) + 90;
        if (angle < 0) {
            angle += 360;
        }
        return Math.round(angle / 30);
    };


    // document.querySelector('html').appendChild(overlay);
    var modal = container.querySelector('#modalWindow');

    $scope.field.cancel = function() {
        overlay.classList.remove('active');
        modal.classList.remove('active');
        if (clock.hourWasSelected) {
            timeInput.classList.add('rui-has-value');
        }
        timeInput.classList.remove('active');
        toggleHourMode();
        clock.validate();
    };

    $scope.field.open = function(e) {
        if (e) {
            e.preventDefault();
        }
        timeInput.classList.add('active');
        timeInput.classList.remove('rui-has-value');
        overlay.classList.add('active');
        modal.classList.add('active');
        recalculateGeometry();
    };

    $scope.field.confirm = function(e) {
        clock.hourWasSelected = true;
        overlay.classList.remove('active');
        $scope.fieldRow =
            (clock.time.hora < 10 ? "0" + clock.time.hora : clock.time.hora) + ":" +
            (clock.time.minuto < 10 ? "0" + clock.time.minuto : clock.time.minuto);
        timeInput.children[1].textContent = $scope.fieldRow;
        modal.classList.remove('active');
        timeInput.classList.remove('active');
        timeInput.classList.add('rui-has-value');
        //timeInput.classList.remove('active');
        toggleHourMode();
        clock.validate();
    };

    overlay.onclick = $scope.field.cancel;
    timeInput.onclick = $scope.field.open;
    clock.okButton.onclick = $scope.field.confirm;
    clock.cancelButton.onclick = $scope.field.cancel;

    window.addEventListener("orientationchange", function() {
        detectOrientationAndRotate();
    }, false);

    /**
     *  C L O C K  M E T H O D S
     */


    var recalculateGeometry = function() {

        var rect = clock.getBoundingClientRect();
        var raioRelogio = (clock.clientHeight / 2);
        clock.detalhesDoCirculoMinuto = {
            x: rect.left + raioRelogio,
            y: rect.top + raioRelogio
        };
        clock.detalhesDoCirculoHora = {
            centerPoint: {
                x: rect.left + 40 + 90,
                y: rect.top + 40 + 90
            },
            radius: 90
        };
    };

    var toggleMinuteMode = function() {
        if (clock.mode === clock.MINUTE_MODE)
            return;

        clock.minuteDisplay.classList.remove('rui-opacity-hidden');
        clock.hourInnerDisplay.classList.add('rui-opacity-hidden');
        clock.hourOutterDisplay.classList.add('rui-opacity-hidden');
        clock.pointer.classList.remove('rui-inner-pointer');
        clock.mode = clock.MINUTE_MODE;
        clock.minuteView.classList.add('active');
        clock.hourView.classList.remove('active');


        var rotationDetails = "rotate3d(0,0,1," + (clock.time.minuto * 6) + "deg)";
        requestAnimationFrame(function() {
            pointerContainer.style.transform = rotationDetails;
        });
    };

    var toggleHourMode = function() {
        if (clock.mode === clock.HOUR_MODE)
            return;


        // esconde os minutos
        clock.minuteDisplay.classList.add('rui-opacity-hidden');
        // mostra as horas
        clock.hourInnerDisplay.classList.remove('rui-opacity-hidden');
        clock.hourOutterDisplay.classList.remove('rui-opacity-hidden');
        clock.pointer.classList.add('rui-inner-pointer');
        clock.minuteView.classList.remove('active');
        clock.hourView.classList.add('active');
        clock.mode = clock.HOUR_MODE;

        var rotationDetails = "rotate3d(0,0,1," + (clock.time.hora * 30) + "deg)";
        requestAnimationFrame(function() {
            pointerContainer.style.transform = rotationDetails;
            if (clock.time.hora <= 12 && clock.time.hora > 0) {
                clock.pointer.classList.add('rui-inner-pointer');

            }
            else {
                clock.pointer.classList.remove('rui-inner-pointer');
            }
        });
    };

    var switchToInnerPointer = function() {
        clock.pointer.classList.add('rui-inner-pointer');
    };

    var switchToOutterPointer = function() {
        clock.pointer.classList.remove('rui-inner-pointer');
    };

    var distanceBetween = function(pointA, pointB) {
        return (Math.sqrt(Math.pow(pointA.x - pointB.x, 2) + Math.pow(pointA.y - pointB.y, 2)));
    };


    var isWithinCircumnference = function(circleProperties, pointToCheck) {
        return (distanceBetween(circleProperties.centerPoint, pointToCheck) <= circleProperties.radius);
    };

    var detectOrientationAndRotate = function() {
        if (orientation === 0 || orientation === 180) {
            modal.classList.remove('landscape');
        }
        else {
            modal.classList.add('landscape');
        }
        setInterval(recalculateGeometry, 800);
    };

    clock.hourView.onclick = toggleHourMode;
    clock.minuteView.onclick = toggleMinuteMode;


    for (var i = 1; i < 60; i++) {
        var n = clock.minuteView.children[0].cloneNode();
        if (i < 10) {
            i = "0" + i;
        }
        n.textContent = i;
        n.style.opacity = '0';
        clock.minuteView.appendChild(n);
    }

    /* GERA OS MOSTRADORES DE HORA */
    for (var j = 1; j < 24; j++) {
        var node = clock.hourView.children[0].cloneNode();
        if (j < 10) {
            j = "0" + j;
        }
        node.textContent = j;
        node.style.opacity = '0';
        clock.hourView.appendChild(node);
    }
    /* DEFINE A HORA PADRAO COMO 12h*/
    clock.hourView.children[0].style.opacity = '0';
    clock.hourView.children[12].style.opacity = '1';
    /* DEFINE A HORA COMO 'ATIVA' (PARA MOSTRAR A FONTE EM BRANCO)*/
    clock.hourView.classList.add('active');
    /**/

    var clearButton = container.querySelector('#fake-input-clear');
    clearButton.onclick = function(event) {
        event.stopPropagation();
        timeInput.classList.remove('rui-has-value');

        clock.children[clock.activeHourArrayPosition].children[clock.activeHour].children[0].style.color = 'black';

        clock.activeHourArrayPosition = 2;
        clock.activeHour = 11;
        clock.children[clock.activeHourArrayPosition].children[0].children[0].style.color = 'white';

        clock.minuteDisplay.children[clock.activeMinute].children[0].style.color = 'black';
        clock.activeMinute = 0;
        clock.minuteDisplay.children[clock.activeMinute].children[0].style.color = 'white';


        clock.hourView.children[clock.time.hora].style.opacity = '0';
        clock.time.hora = 12;
        clock.hourView.children[12].style.opacity = '1';

        clock.minuteView.children[clock.time.minuto].style.opacity = '0';
        clock.time.minuto = 0;
        clock.minuteView.children[0].style.opacity = '1';

        clock.hourWasSelected = false;
        timeInput.children[1].textContent = '';
        $scope.fieldRow = '';
        /*força re-renderização*/
        clock.mode = clock.MINUTE_MODE;
        toggleHourMode();
        /*******/

        clock.validate();

    };
}
