var MapNutritionistController = function(BioEvaluationRepository, AppointmentService, localStorageEngine, ScreenService, MapNutritionistService, Environment, templateManager, eventAggregator, ProfileService, ProfilesRepository, PrescriptionService, Validation, PatientsRepository, ZHPromise, BedsService, CRUD, SynchronizeService, restEngine) {
    var self = this;
    var intoleranciaCrud = CRUD.init("/FoodIntoleranceGroup");
    var normalFeedingCrud = CRUD.init("/NormalFeedings");
    var controlFeedingCrud = CRUD.init("/ControlFeedings");

    eventAggregator.subscribe('callCheckNutritionist', checkNutritionist);

    function fixDateToSave(fieldEdited) {
        var fieldFixed = angular.copy(fieldEdited);
        fieldFixed.date = moment(fieldFixed.date, 'YYYY-MM-DDTHH:mm:ss').format('DD/MM/YYYY HH:mm:ss');
        return fieldFixed;
    }

    this.containerAfterinit = function() {
        if (!templateManager.addEventResize) {
            templateManager.keyboardOpen = false;
            window.addEventListener('resize', function() {
                templateManager.keyboardOpen = !templateManager.keyboardOpen;
            });
            templateManager.addEventResize = true;
        }
        var online = localStorageEngine.getLocalVar('__ONLINE');
        var syncronized = localStorageEngine.getLocalVar('__SYNCRONIZED');
        if (online === false && syncronized === true) {
            eventAggregator.publish("callCheckNutritionist", null);
        } else if (online === false && syncronized === false) {
            var message = ScreenService.i18n('É necessário sincronizar os dados. Deseja realizar agora?');
            ScreenService.confirmMessage(message, 'question', function() {
                eventAggregator.publish("wscCallUpdate", null);
            }, function() {
                ScreenService.openWindow('Dashboard');
            });
        }
    };

    function stopEditting(widget, isEditinCanceled) {

        var isEditingScreen = (widget.showAntrExamList === true && widget.showAddEditAntroExam === true) || (widget.showAddEditBioExam === true && widget.showBioqExamList === true);
        var isListingScreen = widget.showAntrExamList === true || widget.showBioqExamList === true || widget.showPopUpRestr;
        var isEdittingSingleField = widget.curEditing;

        if (widget.isSubeditting) {
            widget.isSubeditting = false;
            widget.subItemData = [];
            widget.view();
        } else if (widget.isLactaryFeedingEdit) {
            widget.view();
        } else if (isEditingScreen) {
            //Fechar editor de exame
            widget.showAddEditBioExam = false;
            widget.showAddEditAntroExam = false;
            widget.view();
        } else if (isListingScreen) {
            //Fechar lista de exame
            widget.selectedRows = [];
            widget.showBioqExamList = false;
            widget.showAntrExamList = false;
            widget.showPopUpRestr = false;
            widget.avaliationExam = {};
            widget.list();
        } else {
            //Fechar Editores simples
            widget.container.showMenu = true;
            widget.fieldEdited.isEditting = false;
            if (isEdittingSingleField) {
                var indexRemoved = widget.curPatient[widget.curEditing].indexOf(widget.fieldEdited);
                if (indexRemoved && indexRemoved > -1 && widget.fieldEdited.__is_new) {
                    widget.curPatient[widget.curEditing].splice(indexRemoved, 1);
                }
            }
            widget.fieldEdited = {};
            widget.list();
        }
        widget.subitemtoadd = '';
        if (Boolean(isEditinCanceled)) {
            returnBackUpRow(widget);
        }

    }

    function returnBackUpRow(widget) {

        if (Boolean(widget.isLactaryFeedingEdit)) {
            returnLactaryFeedingBackup(widget);
        }
        if (Boolean(widget.prescriptionBackup)) {
            returnPrescriptionBackup(widget);
        }
        if (Boolean(widget.appointmentBackup)) {
            returnAppointmentBackup(widget);
        }

        templateManager.updateTemplate();
    }

    function returnAppointmentBackup(widget) {
        var appointmentBackup = widget.appointmentBackup;
        var index;
        if (Boolean(appointmentBackup)) {
            widget.curPatient.Appointments.map(function(appointments, i) {
                if (appointments.date === appointmentBackup.date) {
                    index = i;
                }
            });
            widget.curPatient.Appointments[index] = widget.appointmentBackup;
            delete widget.appointmentBackup;
        }
    }

    function returnLactaryFeedingBackup(widget) {
        var lactaryFeedingBackUp = widget.lactaryFeedingBackUp;

        if (Boolean(lactaryFeedingBackUp)) {
            var curLactaryFeedingIndex;

            widget.currentRow.lactaryFeedings.map(function(a, i) {
                if (a.key === lactaryFeedingBackUp.key) {
                    curLactaryFeedingIndex = i;
                }
            });
            widget.currentRow.lactaryFeedings[curLactaryFeedingIndex] = lactaryFeedingBackUp;
        }
        deleteLactaryFeedingBackupParams(widget);
    }

    function deleteLactaryFeedingBackupParams(widget) {

        delete widget.lactaryFeedingBackUp;
        delete widget.isLactaryFeedingEdit;

    }

    function returnPrescriptionBackup(widget) {
        var prescriptionBackup = widget.prescriptionBackup;
        var index;
        if (Boolean(prescriptionBackup)) {
            widget.curPatient.Prescriptions.map(function(prescriptions, i) {
                if (prescriptions.date === prescriptionBackup.date) {
                    index = i;
                }
            });
            widget.curPatient.Prescriptions[index] = widget.prescriptionBackup;
            delete widget.prescriptionBackup;
        }
    }

    this.cancelPatientEditing = function(widget) {

        widget.isPatientEditing = false;
        widget.isHospitalizationEditing = false;
        widget.list();

        templateManager.updateTemplate();

    };

    function saveProfile(anyWidget) {
        var widget = anyWidget.container.getWidget('WidgetDetailsPatient');
        var curPatientInfo = widget.curPatient;
        var currentRow = widget.currentRow;
        var profile;

        if (widget.fieldEdited && Boolean(widget.fieldEdited.otherData)) {

            currentRow.otherdata = widget.curPatient.Profiles;
            profile = widget.fieldEdited.otherData[0];
            profile.fieldProfileEdit = true;
            profile[widget.fieldEdited.currentEditedName] = widget.fieldEdited.currentEditedModel;

        } else {

            profile = {};
            profile.id = curPatientInfo.id;
            profile.unit = curPatientInfo.unit;
            profile.onlyUpdateLastVist = true;
        }
        var main = anyWidget.container.getWidget('WidgetMain');
        profile.lastVisit = moment().format("DD/MM/YYYY HH:mm:ss");
        profile.confidentiality = profile.confidentiality ? profile.confidentiality : null;
        profile.changed = true;
        profile.__is_new = false;
        SynchronizeService.persistOnline('/Profiles', '/Profiles/save', 'DataSet', [profile]).then(function() {
            profile.changed = false;
            widget.curPatient.lastVisit = moment().format("DD/MM/YYYY HH:mm:ss");
            ProfilesRepository.save(profile);
            PatientsRepository.getPatientById(curPatientInfo.id).then(function(patient) {
                patient.lastVisit = moment().format("DD/MM/YYYY HH:mm:ss");
                PatientsRepository.save(patient).then(function() {
                    main.reload();
                });
            });
        }, function() {
            ProfilesRepository.save(profile);
        });

    }

    function NotFoundFromDataBase(widget, row) {
        var rowToLocalAdd = Array.isArray(widget.localDataSourceLoaded.FoodIntoleranceGroup) && widget.localDataSourceLoaded.FoodIntoleranceGroup.length ? widget.localDataSourceLoaded.FoodIntoleranceGroup.filter(function(filterData) {
            return row.selectedRow === true && filterData.cdpaciente === widget.curPatient.id && filterData.cdgrupprod === row.cdgrupprod && filterData.cdsubgrprod === row.cdsubgrprod;
        })[0] : null;
        if (rowToLocalAdd) {
            intoleranciaCrud.saveRow(rowToLocalAdd, "/FoodIntoleranceGroup");
            widget.dataFoodGroup = widget.dataFoodGroup.concat(angular.copy(rowToLocalAdd));
        }
        if (!rowToLocalAdd) {
            widget.wasChanged = true;
        }
        return rowToLocalAdd ? false : true;

    }

    function saveProfileIntoleranceGroup(widget) {
        var curPatientProfile = widget.curPatient;
        var selectedRows = widget.selectedRows;
        var rowsDiff = [];
        var rowsToAdd = [];
        if (widget.dataFoodGroup && widget.dataFoodGroup.length) {
            rowsDiff = diffArrays(widget.dataFoodGroup, widget.selectedRows);
            rowsDiff.forEach(function(row) {
                if (NotFoundFromDataBase(widget, row)) {
                    row.changed = true;
                    row.__is_new = false;
                    row.lastVisit = moment().format("DD/MM/YYYY HH:mm:ss");
                    row.id = curPatientProfile.id;
                    row.unit = curPatientProfile.unit;
                    row.fieldFoodGroup = true;
                    row.sequential = Date.now();
                    row.cdpaciente = curPatientProfile.id;
                    rowsToAdd.push(row);
                }
            });
        } else {
            selectedRows.forEach(function(row) {
                if (NotFoundFromDataBase(widget, row)) {
                    row.changed = true;
                    row.__is_new = false;
                    row.lastVisit = moment().format("DD/MM/YYYY HH:mm:ss");
                    row.id = curPatientProfile.id;
                    row.cdpaciente = curPatientProfile.id;
                    row.unit = curPatientProfile.unit;
                    row.fieldFoodGroup = true;
                    row.sequential = Date.now();
                    rowsToAdd.push(row);
                }
            });
        }
        var profile = angular.copy(rowsToAdd);
        if (profile && profile.length) {
            widget.savedChangeRestriction = true;
            widget.dataFoodGroup = widget.dataFoodGroup.concat(angular.copy(profile));
            localStorageEngine.save("/FoodIntoleranceGroup", profile).then(function() {
                profile.forEach(function(rowToSave) {
                    intoleranciaCrud.saveRow(rowToSave, "/FoodIntoleranceGroup");
                });
            });
        }
        deleteProfileIntoleranceGroup(widget);
        saveProfile(widget);
    }

    function deleteProfileIntoleranceGroup(widget) {
        var curPatientProfile = widget.curPatient;
        var popupFoodGroup = widget.popupFoodGroup;
        var rowsToDelete = [];

        if (widget.dataFoodGroup && widget.dataFoodGroup.length) {
            popupFoodGroup.forEach(function(row) {
                row.changed = true;
                row.__is_new = false;
                row.onlyUpdateLastVist = true;
                row.lastVisit = moment().format("DD/MM/YYYY HH:mm:ss");
                row.id = curPatientProfile.id;
                row.cdpaciente = curPatientProfile.id;
                row.unit = curPatientProfile.unit;
                row.cdfilial = curPatientProfile.unit;
                row.fieldFoodGroup = true;
                row.sequential = Date.now();
                if (row.selectedRow === false) {
                    rowsToDelete.push(row);
                }
            });
            var profileDelete = angular.copy(rowsToDelete);

            if (profileDelete && profileDelete.length) {
                intoleranciaCrud.removeDataset(profileDelete, "/FoodIntoleranceGroup").then(function() {
                    var index;
                    profileDelete.forEach(function(row) {
                        var deleteArray = widget.dataFoodGroup.filter(function(filterData) {
                            return filterData.cdgrupprod === row.cdgrupprod && filterData.cdsubgrprod === row.cdsubgrprod;
                        })[0];
                        index = widget.dataFoodGroup.indexOf(deleteArray);
                        if (index > -1) {
                            widget.dataFoodGroup.splice(index, 1);
                            widget.wasChanged = true;
                        }
                    });
                    controlVisibilityUpdateRestriction(widget);
                });
            } else if (widget.savedChangeRestriction) {
                controlVisibilityUpdateRestriction(widget);
            }
        }
        var rowsSelected = popupFoodGroup.filter(function(row) {
            return row.selectedRow;
        });
        widget.allFieldsAreSelected = rowsSelected.length === popupFoodGroup.length ? true : false;

        widget.showPopUpRestr = false;
        widget.list();
    }

    function controlVisibilityUpdateRestriction(widget) {
        if (widget.wasChanged === true) {
            updateProcedurePrescription(widget).then(function() {
                if (Array.isArray(widget.patientsToWarning)) {
                    var cdpaciente = widget.curPatient.id;
                    var index = widget.patientsToWarning.indexOf(cdpaciente);
                    if (index > -1) {
                        widget.patientsToWarning.splice(index, 1);
                    }
                }
                ScreenService.showMessage(ScreenService.i18n("Intolerâncias nas Prescrições do Controle Alimentar atualizadas com sucesso!"), 'success');
            }, function() {
                var cdpaciente = widget.curPatient.id;
                if (Array.isArray(widget.patientsToWarning)) {
                    var index = widget.patientsToWarning.indexOf(cdpaciente);
                    if (index === -1) {
                        widget.patientsToWarning.push(cdpaciente);
                    }
                } else {
                    widget.patientsToWarning = [];
                    widget.patientsToWarning.push(cdpaciente);
                }
                ScreenService.showMessage(ScreenService.i18n("Falha na conexão! Atualize as prescrições no Controle Alimentar para verificar inconsistências com as restrições desse paciente!"));

            });
        }
    }
    eventAggregator.subscribe('updateProcedureRestriction', function(widget) {
        controlVisibilityUpdateRestriction(widget);
    });

    eventAggregator.subscribe('callDeleteOnline', function(params) {
        var prescription = params.prescription;

        SynchronizeService.persistOnline('/ControlFeedings', '/ControlFeedings/remove', 'DataSet', [prescription]).then(function() {
            prescription.changed = false;
            prescription.successToRemoveOnline = true;
            controlFeedingCrud.removeRow(prescription, '/ControlFeedings');
        }, function() {
            controlFeedingCrud.removeRow(prescription, '/ControlFeedings');
        });
        saveProfile(params.widgetDetailsPatient);
    });

    eventAggregator.subscribe('callDeletePlatesOnline', function(params) {
        var dataSourceName = params.dataSourceName;
        var plates = params.plates;
        if (typeof plates === 'object' && !Array.isArray(plates)) {
            plates = [plates];
        }
        SynchronizeService.persistOnline(dataSourceName, dataSourceName + '/remove', 'DataSet', plates).then(function() {
            var findParams = {
                'CDFILIAL': params.widgetDetailsPatient.curPatient.unit
            };
            SynchronizeService.persistOnline('/NormalFeedings', '/Structures/find', 'DataSet', [findParams]).then(function(callback) {
                callback.dataset.Plates.normalFeedings = Array.isArray(callback.dataset.Plates.normalFeedings) ? callback.dataset.Plates.normalFeedings : [];
                callback.dataset.Plates.lactaryFeedings = Array.isArray(callback.dataset.Plates.lactaryFeedings) ? callback.dataset.Plates.lactaryFeedings : [];
                callback.dataset.Plates.enteralFeedings = Array.isArray(callback.dataset.Plates.enteralFeedings) ? callback.dataset.Plates.enteralFeedings : [];
                localStorageEngine.setDataSource('/NormalFeedings', callback.dataset.Plates.normalFeedings);
                localStorageEngine.setDataSource('/LactaryFeedings', callback.dataset.Plates.lactaryFeedings);
                localStorageEngine.setDataSource('/EnteralFeedings', callback.dataset.Plates.enteralFeedings);
            }, function() {
                plates.map(function(plate) {
                    plate.successToRemoveOnline = true;
                });
                controlFeedingCrud.removeDataset(plates, dataSourceName);
            });
        }, function() {
            controlFeedingCrud.removeDataset(plates, dataSourceName);
        });
        saveProfile(params.widgetDetailsPatient);
    });

    eventAggregator.subscribe('saveAlterPatient', function(params) {
        var rowToSave = params.rowToSave;
        var dataSourceName = params.dataSourceName;
        var route = params.route;
        var type = params.type;
        if (Array.isArray(rowToSave) && rowToSave.length) {
            SynchronizeService.persistOnline(dataSourceName, route, type, rowToSave).then(function() {
                rowToSave[0].changed = false;
            }).finally(function() {
                params.promise.resolve();
            });

        } else if (typeof rowToSave === 'object') {
            var promise = ZHPromise.defer();
            var arrayKeys = Object.keys(rowToSave);
            arrayKeys.forEach(function(key, index) {
                SynchronizeService.persistOnline(key, route, type, [rowToSave[key]]).then(function() {
                    rowToSave[key].changed = false;
                    if (index === arrayKeys.length - 1) {
                        promise.resolve();
                    }
                });
            });
            promise.then(function() {
                params.promise.resolve();

            });
        }
    });

    function updateProcedurePrescription(widget, filter) {
        var deferred = ZHPromise.defer();
        SynchronizeService.synchronizedIntolerance(widget, filter).then(function(callback) {
            deferred.resolve(callback);
        }, function(callback) {
            deferred.reject(callback);
        });
        return deferred.promise;
    }

    function diffArrays(foodGroup, selectedRows) {
        var diffArray = [];
        if ((foodGroup && !foodGroup.length) || (selectedRows && !selectedRows.length)) {
            return [];
        }
        selectedRows.forEach(function(elem) {
            var row = notInArray(foodGroup, elem);
            if (row) {
                diffArray.push(row);
            }
        });
        return diffArray;
    }

    function notInArray(array, elem) {
        var arr = array.filter(function(row) {
            return row.cdgrupprod === elem.cdgrupprod && row.cdsubgrprod === elem.cdsubgrprod;
        });
        return (arr && arr.length) ? null : elem;
    }

    function savePrescription(fieldEdited, widget) {

        var curPatientPrescriptions = widget.curPatient.Prescriptions;
        if (!curPatientPrescriptions) {
            curPatientPrescriptions = [];
        }
        var diets = widget.localDataSourceLoaded.Diets;

        diets.forEach(function(diet) {
            if (diet.dietId === fieldEdited.dietId) {
                fieldEdited.dietName = diet.dietName;
            }
        });
        if (!fieldEdited.prescription) {
            fieldEdited.prescription = '';
        }
        if (!fieldEdited.clinical) {
            fieldEdited.clinical = '';
        }
        if (!fieldEdited.medicalPrescription) {
            fieldEdited.medicalPrescription = '';
        }
        if (!fieldEdited.nutritionalStatusId) {
            fieldEdited.nutritionalStatusId = '';
        }
        setNewRecordOnReferenceArray(fieldEdited, curPatientPrescriptions);

        var newPrescription = fixDateToSave(fieldEdited);
        SynchronizeService.persistOnline('/Prescriptions', '/Prescriptions/save', 'DataSet', [newPrescription]).then(function() {
            newPrescription.changed = false;
            PrescriptionService.save(newPrescription);
        }, function() {
            PrescriptionService.save(newPrescription);
        });

    }
    eventAggregator.subscribe("AppointmentSave", function(parameters) {
        var widget = parameters[0];
        var avaliationName = parameters[1];
        saveAppointment(widget, avaliationName);
    });

    function isValidAppointmentDate(widget) {
        var parent = widget.getParent();
        var has = false;
        if (parent.curPatient.Appointments) {
            parent.curPatient.Appointments.forEach(function(appointment) {
                if (appointment.date === widget.currentRow.date) {
                    has = true;
                }
            });
        }
        if (widget.changed) {
            return true;
        }
        if (has && widget.currentRow.__is_new && widget.needToSave) {
            ScreenService.showMessage(ScreenService.i18n('Já existe uma consulta marcada para este horário!'));
            return false;
        }
        return true;
    }

    function saveAppointment(widget, avaliationName) {
        var existsAval = widget.existsAval;
        var widgetAppointments = widget.container.getWidget('appointmentsPopup');
        var currentRow = widgetAppointments.currentRow;
        var valid = isValidAppointmentDate(widgetAppointments);
        var aux = angular.copy(currentRow);
        if (currentRow.hasOwnProperty('$$hashKey')) {
            delete aux.$$hashKey;
        }
        if (JSON.stringify(widgetAppointments.backupRow) !== JSON.stringify(aux)) {
            widgetAppointments.needToSave = true;
            widgetAppointments.changed = true;
        }
        if (widgetAppointments.isValid()) {
            if (widgetAppointments.needToSave) {
                if (valid) {
                    var indexEdited;
                    if (widget.curPatient.Appointments) {
                        indexEdited = widget.curPatient.Appointments.indexOf(currentRow);
                    } else {
                        widget.curPatient.Appointments = [];
                        indexEdited = -1;
                    }
                    var data = widget.localDataSourceLoaded;
                    currentRow.unit = widget.curPatient.unit;
                    data.Diets.forEach(function(diet) {
                        if (diet.dietId === currentRow.dietId) {
                            currentRow.dietName = diet.dietName;
                        }
                    });

                    data.HealthInsurance.forEach(function(conv) {
                        if (conv.healthInsuranceId === currentRow.healthInsuranceId) {
                            currentRow.healthInsuranceName = conv.healthInsuranceName;
                        }
                    });

                    if (!currentRow.nutritionalStatusId) {
                        currentRow.nutritionalStatusId = '';
                    } else {
                        data.NutritionalStatus.forEach(function(nut) {
                            if (nut.nutritionalStatusId === currentRow.nutritionalStatusId) {
                                currentRow.nutritionalStatusName = nut.nutritionalStatusName;
                            }
                        });
                    }

                    if (!currentRow.medicalTeamId) {
                        currentRow.medicalTeamId = '';
                    } else {
                        data.MedicalTeams.forEach(function(eqp) {
                            if (eqp.medicalTeamId === currentRow.medicalTeamId) {
                                currentRow.medicalTeamName = eqp.medicalTeamName;
                            }
                        });
                    }

                    currentRow.normalizedDate = moment(currentRow.date, 'YYYY-MM-DDTHH:mm:ss').format('DD/MM/YYYY HH:mm:ss');
                    widget.curPatient.Appointments[indexEdited] = currentRow;
                    widget.curPatient.Appointments[indexEdited].changed = true;

                    widget.curPatient.Appointments[indexEdited].organization = getLocalVar('__NRORGTRAB');

                    var newAppointment = fixDateToSave(currentRow);
                    if (currentRow.__is_new && indexEdited === -1) {
                        widget.curPatient.Appointments.unshift(currentRow);
                    }

                    SynchronizeService.persistOnline('/Appointments', '/Appointments/save', 'DataSet', [newAppointment]).then(function() {
                        newAppointment.changed = false;
                        AppointmentService.save(newAppointment).then(function() {
                            Environment.lastPatientVisit();
                        });
                    }, function() {
                        AppointmentService.save(newAppointment).then(function() {
                            Environment.lastPatientVisit();
                        });
                    });

                    widget.fieldEdited = '';
                    saveProfile(widget);
                    widget.list();
                    Environment.setCurrentAppointmentDate(newAppointment.date);
                    widgetAppointments.needToSave = false;
                    widgetAppointments.changed = false;
                    widgetAppointments.actions[0].label = ScreenService.i18n('Voltar');
                    widgetAppointments.backupRow = angular.copy(widgetAppointments.currentRow);
                    localStorageEngine.setLocalVar('__normalizedAppointment', getLocalVar('__appointment'));
                }
            }
            if (valid) {
                if (avaliationName === 'bioq') {
                    widget.subitemtoadd = 'avaliationbioq';
                    if (existsAval) {
                        var bioExamList = widget.container.getWidget('bioqList');
                        bioExamList.edit();
                        ScreenService.openPopup(bioExamList);
                    } else {
                        openBioEvalPopup(widget);
                    }
                } else if (avaliationName === 'antr') {
                    widget.subitemtoadd = 'avaliationantr';
                    setLocalVar('__appointmentdata', currentRow);
                    var antrList = widget.container.getWidget('antrList');
                    eventAggregator.publish('avaliationsSaved', widget);
                    widget.selectedRows = [];
                    antrList.edit();
                    ScreenService.openPopup(antrList);
                } else {
                    ScreenService.closePopup();
                    widget.list();
                    widget.activate();
                }
            }
        }
    }

    function setNewRecordOnReferenceArray(record, referenceArray) {

        var recordIndex = referenceArray.indexOf(record);

        if (recordIndex === -1) {

            var copiedRecord = angular.copy(record);
            referenceArray.unshift(copiedRecord);

        } else {

            var filteredRecordProperties = Object.keys(referenceArray[recordIndex]);

            filteredRecordProperties.forEach(function(propertie) {
                referenceArray[recordIndex][propertie] = record[propertie];
            });

            referenceArray[recordIndex].changed = true;

        }

    }
    this.redirect = function(widget) {
        if (widget.isValid()) {
            eventAggregator.publish('changeSelectedExam', widget);
            saveBioEvaluation(widget);
        }
    };

    function saveBioEvaluation(widget) {
        var avaliation = widget.currentRow;
        var avaliationFixed;
        var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');

        if (widget.isValid()) {
            avaliation.changed = true;
            if (!avaliation.pregnancyWeek) {
                avaliation.pregnancyWeek = '';
            }
            widgetDetailsPatient.AvaliationFields[6].options.forEach(function(opcao) {
                if (avaliation.pregnancyId && avaliation.pregnancyId === opcao.value) {
                    avaliation.pregnancyName = opcao.name;
                }
            });
            if (widget.isSubItemBeingAdded) {
                avaliation.appointmentDate = getLocalVar('__normalizedAppointment');
                avaliation.age = widgetDetailsPatient.curPatient.age;
                avaliation.gender = widgetDetailsPatient.curPatient.gender;
                avaliation.id = widgetDetailsPatient.curPatient.id;
                avaliation.oldExaminationId = avaliation.examinationId;
                avaliation.unit = widgetDetailsPatient.curPatient.unit;
                avaliation.key = Date.now();

                avaliationFixed = angular.copy(avaliation);
                avaliationFixed.examinationDate = moment(avaliationFixed.examinationDate, 'YYYY-MM-DDTHH:mm:ss').format('DD/MM/YYYY HH:mm:ss');

                if (!widgetDetailsPatient.curPatient.BioEvaluations) {
                    widgetDetailsPatient.curPatient.BioEvaluations = [];
                }
                widgetDetailsPatient.curPatient.BioEvaluations.unshift(avaliation);

                SynchronizeService.persistOnline('/BioEvaluations', '/BioEvaluations/save', 'DataSet', [avaliationFixed]).then(function() {
                    avaliationFixed.changed = false;
                    avaliationFixed.__is_new = false;
                    BioEvaluationRepository.save(avaliationFixed);
                }, function() {
                    BioEvaluationRepository.save(avaliationFixed);

                });

                setDefaultDateFormaOnSolicitationDate(avaliation);
                widgetDetailsPatient.list();
                widgetDetailsPatient.activate();
                ScreenService.closePopup();
                if (!widgetDetailsPatient.existsAval) {
                    var bioExamList = widget.container.getWidget('bioqList');
                    bioExamList.edit();
                    ScreenService.openPopup(bioExamList);
                    widgetDetailsPatient.existsAval = true;
                }
            } else {
                var filter = [{
                    name: "key",
                    operator: "=",
                    value: avaliation.key
                }];
                localStorageEngine.getDataSource("/BioEvaluations", filter).then(function(filteredAvaliation) {
                    filteredAvaliation[0].key = avaliation.key;
                    filteredAvaliation[0].changed = true;
                    filteredAvaliation[0].examinationName = avaliation.examinationName;
                    filteredAvaliation[0].examinationUnit = avaliation.examinationUnit;
                    filteredAvaliation[0].oldExaminationId = filteredAvaliation[0].examinationId;
                    filteredAvaliation[0].examinationStatus = avaliation.examinationStatus;
                    filteredAvaliation[0].examinationId = avaliation.examinationId;
                    filteredAvaliation[0].examinationValue = avaliation.examinationValue;
                    filteredAvaliation[0].pregnancyId = avaliation.pregnancyId;
                    filteredAvaliation[0].pregnancyWeek = avaliation.pregnancyWeek;
                    var aux = moment(avaliation.examinationDate, "YYYY-MM-DDTHH:mm:ss");
                    filteredAvaliation[0].examinationDate = aux._i;
                    if (Array.isArray(widgetDetailsPatient.curPatient.BioEvaluations)) {
                        var index = widgetDetailsPatient.curPatient.BioEvaluations.findIndex(function(bioEvaluation) {
                            return bioEvaluation.key === avaliation.key;
                        });
                        if (index > -1) {
                            widgetDetailsPatient.curPatient.BioEvaluations[index] = angular.copy(filteredAvaliation[0]);
                        }
                    }
                    SynchronizeService.persistOnline('/BioEvaluations', '/BioEvaluations/save', 'DataSet', filteredAvaliation).then(function() {
                        filteredAvaliation[0].changed = false;
                        localStorageEngine.save("/BioEvaluations", filteredAvaliation);
                    }, function() {
                        localStorageEngine.save("/BioEvaluations", filteredAvaliation);

                    });
                });
                avaliation.examinationDate = moment(avaliation.examinationDate, "YYYY-MM-DDTHH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
                ScreenService.closePopup();
            }
            saveProfile(widgetDetailsPatient);
        }
    }

    function setDefaultDateFormaOnSolicitationDate(avaliation) {
        avaliation.examinationDate = moment(avaliation.examinationDate).format("DD/MM/YYYY HH:mm:ss");
    }
    this.closeBioqPopup = function(widget) {
        ScreenService.closePopup();
        widget.list();
        widget.activate();
    };
    this.clearEdited = function(widget) {
        stopEditting(widget, true);
    };

    this.closePopupLactaryEnteral = function(widget) {
        ScreenService.closePopup();
        widget.container.getWidget('WidgetDetailsPatient').list();
        widget.container.getWidget('WidgetDetailsPatient').activate();
        widget.container.showMenu = true;
    };

    this.closePopupItemLacEnt = function(widget) {
        ScreenService.closePopup();
        widget.container.getWidget('widgetPopupPrescricao').view();
    };

    this.closePopup = function(widget) {
        closePopupPrescription(widget);
    };

    function closePopupPrescription(widgetPopup) {
        var widgetPatient = widgetPopup.container.getWidget('WidgetDetailsPatient');
        var widgetPopupPlates = widgetPopup.container.getWidget('widgetPopupPlates');
        widgetPopup.currentRow = {};
        widgetPopupPlates.selectedRows = [];
        widgetPopup.filtredFeedingsForWidget = [];
        ScreenService.closePopup();
        widgetPopup.isVisible = false;
        widgetPatient.list();
        widgetPatient.activate();
        widgetPopup.container.showMenu = true;
    }

    this.saveVal = function(widget) {

        var fieldEdited = widget.fieldEdited;

        if (fieldEdited) {
            var originalIsNewStatus = fieldEdited.originalIsNewStatus ? fieldEdited.originalIsNewStatus : null;
            fieldEdited.__is_new = originalIsNewStatus && originalIsNewStatus === true ? true : fieldEdited.__is_new;
        }

        widget.curEditing = '';
        switch (widget.currentScreen) {
            case 'personalData':
                if (widget.showPopUpRestr === true) {
                    saveProfileIntoleranceGroup(widget);
                } else {
                    saveProfile(widget);
                    stopEditting(widget);
                }
                break;

            case 'nutriApointment':
                if (widget.subitemtoadd === 'avaliationantr') {
                    if (widget.container.getWidget('antrAvaliationPopup').isValid()) {
                        AppointmentService.anthCalculate(widget);
                        saveProfile(widget);
                    }
                } else {
                    saveAppointment(widget);
                    widget.infos = '';
                }
                break;
        }
    };

    this.cancelButton = function(widget) {
        returnBackUpRow(widget);
        ScreenService.closePopup();
        widget.list();
        widget.activate();
    };

    this.cancelBioEval = function(widget) {
        var current = widget.currentRow;
        current.examinationDate = moment(current.examinationDate, "YYYY-MM-DDTHH:mm:ss").format("DD/MM/YYYY HH:mm:ss");
        ScreenService.closePopup();
        widget.container.getWidget('WidgetDetailsPatient').list();
    };

    this.saveDietPrescription = function(widget) {
        var currentRow = widget.currentRow;
        var patientWidget = widget.container.getWidget('WidgetDetailsPatient');
        if (widget.isValid()) {
            if (!patientWidget.prescriptionBackup) {
                var duplicatedDate = false;
                if (patientWidget.curPatient.Prescriptions) {
                    patientWidget.curPatient.Prescriptions.filter(function(prescriptions) {
                        if (prescriptions.date === currentRow.date) {
                            duplicatedDate = true;
                        }
                    });
                    if (duplicatedDate) {
                        ScreenService.showMessage(ScreenService.i18n('Já existe uma prescrição marcada para este horário!'));
                        return false;
                    }
                }
            }
            patientWidget.fieldEdited = '';
            savePrescription(currentRow, patientWidget);
            saveProfile(patientWidget);
            patientWidget.list();
            ScreenService.closePopup();
        }
    };

    this.saveNewPrescription = function(widget) {

        var patientWidget = widget.container.getWidget('WidgetDetailsPatient');
        var widgetPrescricao = widget.container.getWidget('widgetPopupPrescricao');
        var currentRow = widgetPrescricao.currentRow;
        var interval = widget.currentRow.interval;
        var period = widget.currentRow.period;
        var intervalMin;
        var periodMin;
        if (interval && period) {
            intervalMin = (parseInt(interval.split(':')[0]) * 60) + parseInt(interval.split(':')[1]);
            periodMin = (parseInt(period.split(':')[0]) * 60) + parseInt(period.split(':')[1]);
        }
        var fieldAutomatic = widget.getField('automatic');
        var isAutomatic;
        if (fieldAutomatic) {
            isAutomatic = widget.getField('automatic').value();
        }

        if (currentRow.isNewRegister) {
            currentRow.DTINCLUSAO = moment().format('DD/MM/YYYY HH:mm:ss');
        }
        var msg;
        if (widget.isValid()) {
            switch (currentRow.idtpservhosp) {
                case "0":
                case "3":
                case "4":
                case null:
                    if (widget.filtredFeedingsForWidget && widget.filtredFeedingsForWidget.length) {
                        var count = widget.filtredFeedingsForWidget.filter(function(feeding) {
                            return feeding.selectedByUser === true;
                        }).length;
                        if (count === 0 && widget.currentRow.dietService !== '4' && widget.currentRow.idformdiet !== '4') {
                            msg = ScreenService.i18n("Selecione algum prato para salvar a prescrição!");
                            ScreenService.showMessage(msg);
                        } else {
                            saveOralPrescription(widget);
                        }
                    } else if ((currentRow.idtpservhosp === '0' || currentRow.idtpservhosp === '3' ||
                            currentRow.idtpservhosp === '4') || !currentRow.idtpservhosp) {
                        if (widget.currentRow.dietService === '4' || widget.currentRow.idformdiet === '4') {
                            msg = ScreenService.i18n("Selecione algum prato para salvar a prescrição!");
                            ScreenService.showMessage(msg);
                        } else {
                            msg = ScreenService.i18n("Não há cardápio para a configuração informada!");
                            ScreenService.showMessage(msg);
                        }
                    }
                    break;

                case "2":
                    widget.container.getWidget('widgetPopupPrescricao').currentRow.curLactaryFeeding = widget.container.getWidget('widgetPopupItemLac').currentRow;
                    var row = angular.copy(currentRow);
                    row.serviceDate = moment(row.serviceDate, "YYYY-MM-DD").format("DD/MM/YYYY");
                    var contIndex = row.indexOfOriginalControlFeedings;
                    var patiIndex = row.indexOfOriginalCurPatFeedings;
                    if (currentRow.isNewRegister) {
                        currentRow.__is_new = true;
                        saveLactaryPrescription(widget);
                    } else {
                        if (isValidHour(widget.getField('hourLactaryPlate').value())) {
                            if (isAutomatic === 'S') {
                                if (isTimeValid(interval, period)) {
                                    if (intervalMin > periodMin) {
                                        msg = ScreenService.i18n("Tempo de intervalo deve ser menor do que período");
                                        ScreenService.showMessage(msg);
                                    } else if (intervalMin === 0 || periodMin === 0) {
                                        msg = ScreenService.i18n("Tempo de intervalo e período deve ser maior do que 0");
                                        ScreenService.showMessage(msg);
                                    } else {
                                        saveLactaryFeeding(widget);
                                    }
                                }
                            } else {
                                saveLactaryFeeding(widget);
                            }
                        } else {
                            msg = ScreenService.i18n('Hora Ingestão inválida!');
                            ScreenService.showMessage(msg);
                        }
                    }
                    break;

                case "1":
                    if (currentRow.__is_new && !widget.subItemData) {
                        currentRow.serviceDateDefault = currentRow.serviceDate;
                        currentRow.serviceDate = moment(currentRow.serviceDate).format('DD/MM/YYYY');
                        currentRow.id = patientWidget.curPatient.id;
                        currentRow.cdservfili = currentRow.serviceId;
                        currentRow.nutritionist = localStorageEngine.getLocalVar('__CDOPERADOR');
                        currentRow.hospitalization = patientWidget.curPatient.hospitalization;
                        var rowToSave = saveParenteralPrescription(widget);
                        patientWidget.localDataSourceLoaded.ControlFeedings.unshift(rowToSave);
                        patientWidget.curPatient.ControlFeedings.unshift(rowToSave);
                    } else {
                        var fieldVolPrescription = widget.getField('volPrescription');
                        var fieldInfudido = widget.getField('volInfudido');
                        if (fieldVolPrescription && fieldInfudido && fieldInfudido.value() > fieldVolPrescription.value()) {
                            ScreenService.showMessage(ScreenService.i18n('A quantidade infundida deve ser menor ou igual a quantidade prescrita.'));
                        } else {
                            if (isValidHour(widget.getField('time').value())) {
                                if (isAutomatic === 'S') {
                                    if (isTimeValid(interval, period)) {
                                        if (intervalMin > periodMin) {
                                            msg = ScreenService.i18n("Tempo de intervalo deve ser menor do que período!");
                                            ScreenService.showMessage(msg);
                                        } else if (intervalMin === 0 || periodMin === 0) {
                                            msg = ScreenService.i18n("Tempo de intervalo e período deve ser maior do que 0!");
                                            ScreenService.showMessage(msg);
                                        } else {
                                            saveEnteralFeeding(widget);
                                            widget.subItemData = null;
                                            patientWidget.localDataSourceLoaded.ControlFeedings[contIndex] = row;
                                            patientWidget.curPatient.ControlFeedings[patiIndex] = row;
                                        }
                                    }
                                } else {
                                    saveEnteralFeeding(widget);
                                    widget.subItemData = null;
                                    patientWidget.localDataSourceLoaded.ControlFeedings[contIndex] = row;
                                    patientWidget.curPatient.ControlFeedings[patiIndex] = row;
                                }
                            } else {
                                msg = ScreenService.i18n('Hora Ingestão inválida!');
                                ScreenService.showMessage(msg);
                            }
                        }
                    }
                    break;
            }
        }
    };

    function isValidHour(hour) {
        hour = hour.replace(':', '');
        var aux = moment(hour, "HHmm").format("HHmm");
        if (hour === aux) {
            return true;
        } else {
            return false;
        }
    }

    function isTimeValid(interval, period) {
        var minuteInterval = parseInt(interval.split(':')[1]);
        var minutePeriod = parseInt(period.split(':')[1]);
        var msg;

        if (minuteInterval < 60) {
            if (minutePeriod < 60) {
                return true;
            } else {
                msg = ScreenService.i18n('Período inválido!');
                ScreenService.showMessage(msg);
                return false;
            }
        } else {
            msg = ScreenService.i18n('Intervalo inválido!');
            ScreenService.showMessage(msg);
            return false;
        }

    }

    function saveOralPrescription(widget) {
        var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        var nonFormatedDate = widget.currentRow.serviceDate;
        var formatedData = moment(widget.currentRow.serviceDate).format("DD/MM/YYYY");
        widget.currentRow.serviceDate = widget.currentRow.__is_new && formatedData !== "Invalid date" ? formatedData : widget.currentRow.serviceDate;
        templateManager.bkpCurrentRowPrescription = angular.copy(widget.currentRow);
        var currentRow = widget.currentRow;
        var normalFeedings = widget.filtredFeedingsForWidget;
        if (currentRow && currentRow.isNewRegister) {
            currentRow.hospitalization = widgetDetailsPatient.curPatient.hospitalization;
            currentRow.id = widgetDetailsPatient.curPatient.id;
            currentRow.serviceDateDefault = nonFormatedDate;
            currentRow.cdservfili = currentRow.serviceId;
            var rowToSave = createRowToSavePrescription(widget);
            currentRow.serviceDate = formatedData;
            var promise = ZHPromise.defer();
            SynchronizeService.persistOnline('/ControlFeedings', '/ControlFeedings/save', 'DataSet', [rowToSave]).then(function(callback) {
                rowToSave.changed = false;
                rowToSave.__is_new = false;
                if (callback && callback.dataset && callback.dataset.error && callback.dataset.error.SEQUENTIAL) {
                    rowToSave.sequential = callback.dataset.error.SEQUENTIAL;
                }
                MapNutritionistService.savePrescription(rowToSave);
            }, function() {
                MapNutritionistService.savePrescription(rowToSave);
            }).finally(function() {
                promise.resolve();
            });
            promise.then(function() {
                saveOralPrescriptionNormalFeedings(rowToSave, normalFeedings, widgetDetailsPatient).then(function() {
                    widgetDetailsPatient.wasChanged = true;
                    if (currentRow.idformdiet !== '4' && currentRow.dietService !== '4') {
                        updateProcedurePrescription(widgetDetailsPatient, {
                            id: currentRow.id,
                            serviceDate: currentRow.serviceDate,
                            DTINCLUSAO: rowToSave.DTINCLUSAO
                        }).then(function() {
                            if (Array.isArray(widgetDetailsPatient.patientsToWarning)) {
                                var cdpaciente = widgetDetailsPatient.curPatient.id;
                                var index = widgetDetailsPatient.patientsToWarning.indexOf(cdpaciente);
                                if (index > -1) {
                                    widgetDetailsPatient.patientsToWarning.splice(index, 1);
                                }
                            }
                            ScreenService.showMessage(ScreenService.i18n("Restrições alimentares verificadas com sucesso para esta prescrição!"), 'success');
                        }, function() {
                            var cdpaciente = widgetDetailsPatient.curPatient.id;
                            if (Array.isArray(widgetDetailsPatient.patientsToWarning)) {
                                var index = widgetDetailsPatient.patientsToWarning.indexOf(cdpaciente);
                                if (index === -1) {
                                    widgetDetailsPatient.patientsToWarning.push(cdpaciente);
                                }
                            } else {
                                widgetDetailsPatient.patientsToWarning = [];
                                widgetDetailsPatient.patientsToWarning.push(cdpaciente);
                            }
                            ScreenService.showMessage(ScreenService.i18n("Falha na conexão! Atualize as prescrições no Controle Alimentar para verificar inconsistências com as restrições desse paciente!"));
                        });
                    }
                });
                widgetDetailsPatient.localDataSourceLoaded.ControlFeedings.unshift(rowToSave);
                widgetDetailsPatient.curPatient.ControlFeedings.unshift(rowToSave);
            });
        } else {
            if (widget.currentRow.idformdiet === '4' || widget.currentRow.dietService === '4') {
                saveSpecialDiet(widget);
            } else {
                saveNormalFeedingsEdit(widget);
            }
        }
        closePopupPrescription(widget);
        saveProfile(widgetDetailsPatient);
    }

    function rowsToInsertUpdateDeleteNormalFeedings(widgetPopupPrescricao) {
        var rowsToInsert = [];
        var rowsToUpdate = [];
        var rowsToDelete = [];
        var rows;
        widgetPopupPrescricao.filtredFeedingsForWidget.forEach(function(feeding) {
            rowsToDelete = widgetPopupPrescricao.bkpFeedings.filter(function(bkp) {
                if ((bkp.formulationId !== feeding.formulationId || bkp.plateType !== feeding.plateType) && !feeding.key && !feeding.alreadyInserted) {
                    rowsToInsert.push(feeding);
                    feeding.alreadyInserted = true;
                }
                if ((bkp.formulationId === feeding.formulationId && bkp.plateType === feeding.plateType) && !bkp.remove && feeding.key) {
                    rowsToUpdate.push(feeding);
                }
                return (bkp.formulationId !== feeding.formulationId || bkp.plateType !== feeding.plateType) && bkp.remove;
            });
        });
        rowsToDelete.map(function(row) {
            row.manualDelete = true;
        });
        rows = {
            'rowsToInsert': rowsToInsert,
            'rowsToUpdate': rowsToUpdate,
            'rowsToDelete': rowsToDelete
        };
        return rows;
    }

    function saveSpecialDiet(widgetPopupPrescricao) {
        var widgetDetailsPatient = widgetPopupPrescricao.container.getWidget('WidgetDetailsPatient');
        var currentRow = angular.copy(widgetPopupPrescricao.currentRow);
        var rows = rowsToInsertUpdateDeleteNormalFeedings(widgetPopupPrescricao);
        var normalFeedings = rows.rowsToUpdate;
        var savedOnline;
        var rowsToSave;
        if (Array.isArray(rows.rowsToInsert) && rows.rowsToInsert.length) {
            currentRow.serviceDate = moment(currentRow.serviceDate, 'YYYY-MM-DD').format('DD/MM/YYYY');
            rowsToSave = createRowsToRelateNormalFeedingsToOralPrescription(widgetPopupPrescricao.currentRow, rows.rowsToInsert, widgetDetailsPatient);
        }
        if (Array.isArray(rows.rowsToDelete) && rows.rowsToDelete.length) {
            SynchronizeService.persistOnline('/NormalFeedings', '/NormalFeedings/remove', 'DataSet', rows.rowsToDelete).then(function() {
                var findParams = {
                    'CDFILIAL': widgetDetailsPatient.curPatient.unit,
                    'type': 'normalFeedings'
                };
                SynchronizeService.persistOnline('/NormalFeedings', '/Structures/find', 'DataSet', [findParams]).then(function(callback) {
                    callback.dataset.Plates.normalFeedings = Array.isArray(callback.dataset.Plates.normalFeedings) ? callback.dataset.Plates.normalFeedings : [];
                    // callback.dataset.Plates.lactaryFeedings = Array.isArray(callback.dataset.Plates.lactaryFeedings) ? callback.dataset.Plates.lactaryFeedings : [];
                    localStorageEngine.setDataSource('/NormalFeedings', callback.dataset.Plates.normalFeedings);
                    // localStorageEngine.setDataSource('/LactaryFeedings', callback.dataset.Plates.lactaryFeedings);
                }, function() {
                    rows.rowsToDelete.forEach(function(rowDelete) {
                        rowDelete.successToRemoveOnline = true;
                        normalFeedingCrud.removeRow(rowDelete, '/NormalFeedings');
                    });
                });
            }, function() {
                rows.rowsToDelete.forEach(function(rowDelete) {
                    normalFeedingCrud.removeRow(rowDelete, '/NormalFeedings');
                });
            });

        }
        var rowsToSaveInsert = createRowsToRelateNormalFeedingsToOralPrescription(widgetPopupPrescricao.currentRow, rows.rowsToInsert, widgetDetailsPatient);
        var rowsToInsertOrUpdate = rowsToSaveInsert.concat(rows.rowsToUpdate);
        if (Array.isArray(rowsToInsertOrUpdate) && rowsToInsertOrUpdate.length) {
            savedOnline = saveOnlineNormalFeedings(widgetDetailsPatient, rowsToInsertOrUpdate, rowsToSave);
        }
        savedOnline.then(function(successSaveOnline) {
            normalFeedings.forEach(function(normalFeeding, index) {
                var filter = [{
                    name: 'key',
                    operator: '=',
                    value: ''
                }];
                filter[0].value = normalFeeding.key;
                localStorageEngine.getDataSource("/NormalFeedings", filter).then(function(filteredNormalFeeding) {
                    filteredNormalFeeding = filteredNormalFeeding[0];
                    filteredNormalFeeding.changed = !successSaveOnline;
                    filteredNormalFeeding.selectedByUser = normalFeeding.selectedByUser;
                    filteredNormalFeeding.__is_new = normalFeeding.__is_new;
                    filteredNormalFeeding.unit = normalFeeding.unit;
                    filteredNormalFeeding.id = normalFeeding.id;
                    filteredNormalFeeding.serviceDate = normalFeeding.serviceDate;
                    filteredNormalFeeding.observation = normalFeeding.observation;
                    if (successSaveOnline && successSaveOnline.dataset && successSaveOnline.dataset.error && Array.isArray(successSaveOnline.dataset.error.SEQUENTIAL) && successSaveOnline.dataset.error.SEQUENTIAL.length) {
                        filteredNormalFeeding[0].sequential = successSaveOnline.dataset.error.SEQUENTIAL[index];
                    }
                    localStorageEngine.save("/NormalFeedings", filteredNormalFeeding);
                });
            });

        });
        saveProfile(widgetDetailsPatient);
    }

    function saveOnlineNormalFeedings(widgetDetailsPatient, rowsToInsertOrUpdate, rowsToSave) {
        var saveOnline = ZHPromise.defer();
        var widgetPopupPrescricao = widgetDetailsPatient.container.getWidget('widgetPopupPrescricao');
        if (!rowsToSave) {
            rowsToSave = rowsToInsertOrUpdate;
        }
        SynchronizeService.persistOnline('/NormalFeedings', '/NormalFeedings/save', 'DataSet', rowsToInsertOrUpdate).then(function(callback) {
            var findParams = {
                'CDFILIAL': widgetDetailsPatient.curPatient.unit,
                'type': 'normalFeedings'
            };
            SynchronizeService.persistOnline('/NormalFeedings', '/Structures/find', 'DataSet', [findParams]).then(function(callbackPlates) {
                callbackPlates.dataset.Plates.normalFeedings = Array.isArray(callbackPlates.dataset.Plates.normalFeedings) ? callbackPlates.dataset.Plates.normalFeedings : [];
                // callbackPlates.dataset.Plates.lactaryFeedings = Array.isArray(callbackPlates.dataset.Plates.lactaryFeedings) ? callbackPlates.dataset.Plates.lactaryFeedings : [];
                localStorageEngine.setDataSource('/NormalFeedings', callbackPlates.dataset.Plates.normalFeedings);
                // localStorageEngine.setDataSource('/LactaryFeedings', callbackPlates.dataset.Plates.lactaryFeedings);
                updateControlFeedingRestriction(widgetDetailsPatient, widgetPopupPrescricao.currentRow).then(function() {
                    saveOnline.reject();
                });
            }, function() {
                if (callback && callback.dataset && callback.dataset.error && Array.isArray(callback.dataset.error.SEQUENTIAL) && Array.isArray(rowsToSave)) {
                    rowsToSave.forEach(function(row, index) {
                        row.unique = callback.dataset.error.SEQUENTIAL[index];
                    });

                    MapNutritionistService.saveOralPrescriptionNormalFeedings(rowsToSave, false);
                }
                updateControlFeedingRestriction(widgetDetailsPatient, widgetPopupPrescricao.currentRow).then(function() {
                    saveOnline.resolve(callback);
                });
            });
        }, function() {
            if (rowsToSave) {
                if (Array.isArray(rowsToSave)) {
                    rowsToSave.map(function(row) {
                        row.changed = true;
                    });
                } else {
                    rowsToSave.changed = true;
                }
                localStorageEngine.save('/NormalFeedings', rowsToSave).then(function() {
                    var currentRowPrescription = templateManager.bkpCurrentRowPrescription;
                    if (currentRowPrescription.idformdiet !== '4' && currentRowPrescription.dietService !== '4') {
                        updateControlFeedingRestriction(widgetDetailsPatient, widgetPopupPrescricao.currentRow).then(function() {
                            saveOnline.resolve(false);
                        }).finally(function() {
                            saveOnline.resolve(false);
                        });
                    } else {
                        saveOnline.resolve(false);
                    }
                });
            }
        });
        return saveOnline;
    }

    function saveNormalFeedingsEdit(widget) {

        var widgetPopupPrescricao = widget.container.getWidget('widgetPopupPrescricao');
        var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        var currentRow = angular.copy(widgetPopupPrescricao.currentRow);
        var normalFeedings = widgetPopupPrescricao.filtredFeedingsForWidget;
        var filter = [{
                "name": "unit",
                "operator": "=",
                "value": localStorageEngine.getLocalVar('__CDFILIAL')
            },
            {
                "name": "id",
                "operator": "=",
                "value": localStorageEngine.getLocalVar('__patient')
            },
            {
                "name": "serviceDate",
                "operator": "=",
                "value": moment(currentRow.serviceDate, 'YYYY-MM-DD').format('DD/MM/YYYY')
            },
            {
                "name": "sequential",
                "operator": "=",
                "value": currentRow.sequential
            },
            {
                "name": "unique",
                "operator": "=",
                "value": ""
            }
        ];
        //var rowsToSave = //createRowsToRelateNormalFeedingsToOralPrescription(currentRow, normalFeedings, widgetDetailsPatient);
        if (normalFeedings && normalFeedings.length) {
            var savedOnline = saveOnlineNormalFeedings(widgetDetailsPatient, normalFeedings);
            var promisesSaveNormalFeedingsEdit = [];
            savedOnline.then(function(successSaveOnline) {
                if (successSaveOnline) {
                    normalFeedings.forEach(function(normalFeeding) {
                        var filterCopied = angular.copy(filter);
                        filterCopied[filterCopied.length - 1].value = normalFeeding.unique;
                        localStorageEngine.getDataSource("/NormalFeedings", filterCopied).then(function(filteredNormalFeeding) {
                            filteredNormalFeeding[0].changed = !successSaveOnline;
                            filteredNormalFeeding[0].selectedByUser = normalFeeding.selectedByUser;
                            filteredNormalFeeding[0].__is_new = normalFeeding.__is_new;
                            filteredNormalFeeding[0].unit = normalFeeding.unit;
                            filteredNormalFeeding[0].id = normalFeeding.id;
                            filteredNormalFeeding[0].serviceDate = normalFeeding.serviceDate;
                            filteredNormalFeeding[0].observation = normalFeeding.observation;
                            promisesSaveNormalFeedingsEdit.push(localStorageEngine.save("/NormalFeedings", filteredNormalFeeding));
                        });
                    });
                    ZHPromise.all(promisesSaveNormalFeedingsEdit).then(function() {
                        updateControlFeedingRestriction(widget, currentRow);
                    });
                }
            });

        }
    }

    function updateControlFeedingRestriction(widget, prescription) {
        var endUpdate = ZHPromise.defer();
        var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        var serviceDate = moment(prescription.serviceDate, "DD/MM/YYYY");
        var currentRowPrescription = templateManager.bkpCurrentRowPrescription;
        if (serviceDate.isValid()) {
            serviceDate = prescription.serviceDate;
        } else {
            serviceDate = moment(prescription.serviceDate, "YYYY-MM-DD").format("DD/MM/YYYY");
        }
        var filterControlFeedings = {
            "id": widgetDetailsPatient.curPatient.id,
            "serviceDate": moment(currentRowPrescription.serviceDate, 'YYYY-MM-DD').format('DD/MM/YYYY'),
            "DTINCLUSAO": currentRowPrescription.DTINCLUSAO
        };
        widgetDetailsPatient.wasChanged = true;
        updateProcedurePrescription(widgetDetailsPatient, filterControlFeedings).then(function() {
            if (Array.isArray(widgetDetailsPatient.patientsToWarning)) {
                var cdpaciente = widgetDetailsPatient.curPatient.id;
                var index = widgetDetailsPatient.patientsToWarning.indexOf(cdpaciente);
                if (index > -1) {
                    widgetDetailsPatient.patientsToWarning.splice(index, 1);
                }
            }
            endUpdate.resolve();
            ScreenService.showMessage(ScreenService.i18n("Restrições alimentares verificadas com sucesso para esta prescrição!"), 'success');
        }, function() {
            var cdpaciente = widgetDetailsPatient.curPatient.id;
            if (Array.isArray(widgetDetailsPatient.patientsToWarning)) {
                var index = widgetDetailsPatient.patientsToWarning.indexOf(cdpaciente);
                if (index === -1) {
                    widgetDetailsPatient.patientsToWarning.push(cdpaciente);
                }
            } else {
                widgetDetailsPatient.patientsToWarning = [];
                widgetDetailsPatient.patientsToWarning.push(cdpaciente);
            }
            endUpdate.resolve();
            ScreenService.showMessage(ScreenService.i18n("Falha na conexão! Atualize as prescrições no Controle Alimentar para verificar inconsistências com as restrições desse paciente!"));
        });
        return endUpdate;
    }

    function createRowToSavePrescription(widget) {

        var copiedFieldEdited = angular.copy(widget.currentRow);

        copiedFieldEdited.changed = true;
        copiedFieldEdited.sequential = Date.now();
        copiedFieldEdited.service = copiedFieldEdited.serviceName;
        copiedFieldEdited.serviceId = copiedFieldEdited.idtpservhosp;
        copiedFieldEdited.serviceCode = copiedFieldEdited.serviceId;
        copiedFieldEdited.unit = localStorageEngine.getLocalVar('__CDFILIAL');
        copiedFieldEdited.nutritionist = localStorageEngine.getLocalVar('__CDOPERADOR');
        copiedFieldEdited.cdservfili = widget.currentRow.serviceId;
        var curDate = moment(copiedFieldEdited.serviceDateDefault).format("DD/MM/YYYY");
        copiedFieldEdited.serviceDate = curDate === "Invalid date" ? copiedFieldEdited.serviceDate : curDate;

        return copiedFieldEdited;
    }

    function saveOralPrescriptionNormalFeedings(currentOralPrescription, normalFeedings, widgetDetailsPatient) {
        var endSave = ZHPromise.defer();
        var rowsToSave = createRowsToRelateNormalFeedingsToOralPrescription(currentOralPrescription, normalFeedings, widgetDetailsPatient);
        SynchronizeService.persistOnline('/NormalFeedings', '/NormalFeedings/save', 'DataSet', rowsToSave).then(function(callback) {
            var findParams = {
                'CDFILIAL': widgetDetailsPatient.curPatient.unit,
                'type': 'normalFeedings'
            };
            SynchronizeService.persistOnline('/NormalFeedings', '/Structures/find', 'DataSet', [findParams]).then(function(callbackPlates) {
                callbackPlates.dataset.Plates.normalFeedings = Array.isArray(callbackPlates.dataset.Plates.normalFeedings) ? callbackPlates.dataset.Plates.normalFeedings : [];
                // callbackPlates.dataset.Plates.lactaryFeedings = Array.isArray(callbackPlates.dataset.Plates.lactaryFeedings) ? callbackPlates.dataset.Plates.lactaryFeedings : [];
                // var promises = [];
                // promises.push();
                // promises.push(localStorageEngine.setDataSource('/LactaryFeedings', callbackPlates.dataset.Plates.lactaryFeedings));
                widgetDetailsPatient.curPatient.NormalFeedings = callbackPlates.dataset.Plates.normalFeedings.filter(function(normalFeeding) {
                    return normalFeeding.id === widgetDetailsPatient.curPatient.id;
                });
                // widgetDetailsPatient.curPatient.LactaryFeedings = callbackPlates.dataset.Plates.lactaryFeedings.filter(function(lactaryFeeding) {
                //     return lactaryFeeding.id === widgetDetailsPatient.curPatient.id;
                // });
                localStorageEngine.setDataSource('/NormalFeedings', callbackPlates.dataset.Plates.normalFeedings).then(function() {
                    endSave.resolve();
                });
            }, function() {
                if (callback && callback.dataset && callback.dataset.error && Array.isArray(callback.dataset.error.SEQUENTIAL) && callback.dataset.error.SEQUENTIAL.length && Array.isArray(rowsToSave) && rowsToSave.length) {
                    rowsToSave.forEach(function(row, index) {
                        row.unique = callback.dataset.error.SEQUENTIAL[index];
                    });
                }
                MapNutritionistService.saveOralPrescriptionNormalFeedings(rowsToSave, false).then(function() {
                    endSave.resolve();
                });
            });
        }, function() {
            localStorageEngine.save('/NormalFeedings', rowsToSave).then(function() {
                endSave.resolve();
            });
        });
        return endSave;
    }

    function createRowsToRelateNormalFeedingsToOralPrescription(oralPrescription, normalFeedings, widgetDetailsPatient) {

        var unique = 0;
        var objects = [];

        normalFeedings.forEach(function(normalFeeding) {
            unique++;
            var serviceDate = moment(oralPrescription.serviceDate, 'DD/MM/YYYY');
            // if (dish.IDOPCCNFCPME === 'S') dish.NMTIPOPRAT += ' (Opção)';
            var plateTypeName = oralPrescription.idformdiet === "4" || oralPrescription.dietService === "4" ? normalFeeding.plateTypeName : normalFeeding.plateType;
            var object = {
                "id": oralPrescription.id,
                "unit": localStorageEngine.getLocalVar('__CDFILIAL'),
                "serviceId": oralPrescription.serviceId ? oralPrescription.serviceId : oralPrescription.cdservfili,
                "key": Date.now(),
                "unique": Validation.strPad(unique, 4),
                "plateName": normalFeeding.plateName,
                "plateType": normalFeeding.idopccnfcard === 'S' ?
                    (normalFeeding.cdtipoprat ? normalFeeding.cdtipoprat + ' (Opção)' : normalFeeding.plateType + ' (Opção)') : (normalFeeding.cdtipoprat ? normalFeeding.cdtipoprat : normalFeeding.plateType),
                "plateTypeName": plateTypeName,
                "serviceDate": serviceDate.isValid() ? oralPrescription.serviceDate : moment(oralPrescription.serviceDate, 'YYYY-MM-DD').format('DD/MM/YYYY'),
                "service": oralPrescription.idtpservhosp,
                "plateNumbers": "1",
                "plateAuxId": 'P',
                "formulationId": normalFeeding.codplate && !normalFeeding.formulationId ? normalFeeding.codplate : normalFeeding.formulationId,
                "observation": normalFeeding.observation,
                "dietId": oralPrescription.dietId,
                "changed": true,
                "__is_new": true,
                "selectedByUser": normalFeeding.selectedByUser ? normalFeeding.selectedByUser : false,
                "isRequiredOnMenu": normalFeeding.isRequiredOnMenu,
                "cdservfili": oralPrescription.cdservfili,
                "codplate": normalFeeding.codplate,
                "sequential": oralPrescription.sequential,
                "DTINCLUSAO": oralPrescription.DTINCLUSAO
            };
            objects.push(object);
            widgetDetailsPatient.localDataSourceLoaded.NormalFeedings.unshift(object);

        });
        return objects;
    }

    function saveLactaryPrescription(widget) {

        var currentRow = widget.currentRow;
        var widgetPatient = widget.container.getWidget('WidgetDetailsPatient');
        if (widget.isValid()) {
            var promise = ZHPromise.defer();
            currentRow.serviceDateDefault = currentRow.serviceDate;
            currentRow.serviceDate = moment(currentRow.serviceDate).format('DD/MM/YYYY');

            setLactaryPrescriptionDefaultValues(currentRow);
            var rowToSave = createRowToSavePrescription(widget);
            SynchronizeService.persistOnline('/ControlFeedings', '/ControlFeedings/save', 'DataSet', [rowToSave]).then(function(callback) {
                rowToSave.changed = false;
                rowToSave.__is_new = false;
                if (callback && callback.dataset && callback.dataset.error && callback.dataset.error.SEQUENTIAL) {
                    rowToSave.sequential = callback.dataset.error.SEQUENTIAL;
                }
                MapNutritionistService.savePrescription(rowToSave);
                promise.resolve(rowToSave.sequential);
            }, function() {
                MapNutritionistService.savePrescription(rowToSave);
                promise.resolve(rowToSave.sequential);
            });

            promise.then(function(sequential) {
                currentRow.sequential = sequential;
                widgetPatient.localDataSourceLoaded.ControlFeedings.unshift(currentRow);
                widgetPatient.curPatient.ControlFeedings.unshift(currentRow);
            });
            ScreenService.closePopup();
            saveProfile(widgetPatient);

        }
    }

    function saveLactaryFeeding(widget) {
        var widgetPopupPrescricao = widget.container.getWidget('widgetPopupPrescricao');
        var curLactaryFeeding = widgetPopupPrescricao.currentRow.curLactaryFeeding;
        curLactaryFeeding.DTINCLUSAO = widgetPopupPrescricao.currentRow.DTINCLUSAO;
        if (widget.isValid()) {
            if (!Boolean(curLactaryFeeding.key)) {
                saveNewLactaryFeeding(widget);
            } else {
                saveLactaryFeedingOnPrescriptionEdit(widget);
                var index = widgetPopupPrescricao.currentRow.lactaryFeedings.findIndex(function(feeding) {
                    return feeding.key === widget.currentRow.key;
                });
                var lactaryDate = moment(widget.currentRow.lactaryDate, "YYYY-MM-DD").format("DD/MM/YYYY");
                var hourLactaryPlate = moment(widget.currentRow.hourLactaryPlate, 'HHmm').format('HH:mm');
                widget.currentRow.lactaryDate = lactaryDate;
                widget.currentRow.hourLactaryPlate = hourLactaryPlate;
                widgetPopupPrescricao.currentRow.lactaryFeedings[index] = widget.currentRow;
            }
        }
    }

    function saveNewLactaryFeeding(widget) {

        var currentRow = widget.container.getWidget('widgetPopupPrescricao').currentRow;
        var curLactaryFeeding = currentRow.curLactaryFeeding;
        var isAutomatic = widget.getField('automatic').value();
        var lactaryFeeding;
        var rowsToSave = [];
        var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        lactaryFeeding = createRowToRelateLactaryFeedingToLactaryPrescription(widget);
        rowsToSave.push(lactaryFeeding);
        widgetDetailsPatient.localDataSourceLoaded.LactaryFeedings.unshift(lactaryFeeding);
        widgetDetailsPatient.curPatient.LactaryFeedings.unshift(lactaryFeeding);
        setNewRecordOnReferenceArray(lactaryFeeding, currentRow.lactaryFeedings);
        if (isAutomatic === 'S') {
            var arrayDateLactary = saveAutoFills(curLactaryFeeding, 'lactaryDate', 'hourLactaryPlate');
            arrayDateLactary.forEach(function(data) {
                var obj = moment(data, "YYYY-MM-DD HHmm");
                var dt = obj.format("YYYY-MM-DD");
                var hr = obj.format("HHmm");
                lactaryFeeding = createRowToRelateLactaryFeedingToLactaryPrescription(widget, dt, hr);
                rowsToSave.push(lactaryFeeding);
                widgetDetailsPatient.localDataSourceLoaded.LactaryFeedings.unshift(lactaryFeeding);
                widgetDetailsPatient.curPatient.LactaryFeedings.unshift(lactaryFeeding);
                setNewRecordOnReferenceArray(lactaryFeeding, currentRow.lactaryFeedings);
            });
        }
        SynchronizeService.persistOnline('/LactaryFeedings', '/LactaryFeedings/save', 'DataSet', rowsToSave).then(function(response) {
            var findParams = {
                'CDFILIAL': widgetDetailsPatient.curPatient.unit,
                'type': 'lactaryFeedings'
            };
            SynchronizeService.persistOnline('/LactaryFeedings', '/Structures/find', 'DataSet', [findParams]).then(function(callback) {
                // callback.dataset.Plates.normalFeedings = Array.isArray(callback.dataset.Plates.normalFeedings) ? callback.dataset.Plates.normalFeedings : [];
                callback.dataset.Plates.lactaryFeedings = Array.isArray(callback.dataset.Plates.lactaryFeedings) ? callback.dataset.Plates.lactaryFeedings : [];
                // localStorageEngine.setDataSource('/NormalFeedings', callback.dataset.Plates.normalFeedings);
                localStorageEngine.setDataSource('/LactaryFeedings', callback.dataset.Plates.lactaryFeedings);
                widgetDetailsPatient.localDataSourceLoaded.LactaryFeedings = angular.copy(callback.dataset.Plates.lactaryFeedings);
                widgetDetailsPatient.curPatient.LactaryFeedings = callback.dataset.Plates.lactaryFeedings.filter(function(lactaryFeeding) {
                    return lactaryFeeding.id === widgetDetailsPatient.curPatient.id;
                });
                var datePrescription = currentRow.serviceDate;
                var dateFormat = datePrescription.indexOf('/') > -1 ? datePrescription : moment(datePrescription).format('DD/MM/YYYY');
                currentRow.lactaryFeedings = widgetDetailsPatient.curPatient.LactaryFeedings.filter(function(lactaryFeeding) {
                    return lactaryFeeding.sequential === currentRow.sequential && lactaryFeeding.serviceDate === dateFormat;
                });
            }, function() {
                if (response && response.dataset && response.dataset.error && Array.isArray(response.dataset.error.SEQUENTIAL)) {
                    rowsToSave.forEach(function(row, index) {
                        row.unique = response.dataset.error.SEQUENTIAL[index];
                    });
                }
                MapNutritionistService.saveLactaryFeeding(rowsToSave, false);
            });

        }, function() {
            MapNutritionistService.saveLactaryFeeding(rowsToSave);
        });

        curLactaryFeeding.key = lactaryFeeding.key;
        ScreenService.closePopup();
        widget.container.getWidget('widgetPopupPrescricao').view();
        deleteLactaryFeedingBackupParams(widget);
        saveProfile(widgetDetailsPatient);

    }

    function saveLactaryFeedingOnPrescriptionEdit(widget) {

        var curLactaryFeeding = widget.container.getWidget('widgetPopupPrescricao').currentRow.curLactaryFeeding;
        var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        var filter = [{
            "name": "key",
            "operator": "=",
            "value": curLactaryFeeding.key
        }];

        localStorageEngine.getDataSource("/LactaryFeedings", filter).then(function(filteredLactaryFeeding) {
            filteredLactaryFeeding[0].changed = true;
            filteredLactaryFeeding[0].observation = curLactaryFeeding.observation;
            filteredLactaryFeeding[0].plateAuxId = 'P';
            filteredLactaryFeeding[0].formulationId = curLactaryFeeding.formulationId;
            filteredLactaryFeeding[0].plateNumbers = curLactaryFeeding.plateNumbers;
            filteredLactaryFeeding[0].hourLactaryPlate = moment(curLactaryFeeding.hourLactaryPlate, "HHmm").format("HH:mm");
            filteredLactaryFeeding[0].lactaryDate = moment(curLactaryFeeding.lactaryDate, "DD/MM/YYYY").format("DD/MM/YYYY");
            filteredLactaryFeeding[0].DTINCLUSAO = curLactaryFeeding.DTINCLUSAO;
            SynchronizeService.persistOnline('/LactaryFeedings', '/LactaryFeedings/save', 'DataSet', filteredLactaryFeeding).then(function() {
                var findParams = {
                    'CDFILIAL': widgetDetailsPatient.curPatient.unit,
                    'type': 'lactaryFeedings'
                };
                SynchronizeService.persistOnline('/LactaryFeedings', '/Structures/find', 'DataSet', [findParams]).then(function(callback) {
                    // callback.dataset.Plates.normalFeedings = Array.isArray(callback.dataset.Plates.normalFeedings) ? callback.dataset.Plates.normalFeedings : [];
                    callback.dataset.Plates.lactaryFeedings = Array.isArray(callback.dataset.Plates.lactaryFeedings) ? callback.dataset.Plates.lactaryFeedings : [];
                    // localStorageEngine.setDataSource('/NormalFeedings', callback.dataset.Plates.normalFeedings);
                    localStorageEngine.setDataSource('/LactaryFeedings', callback.dataset.Plates.lactaryFeedings);
                }, function() {
                    filteredLactaryFeeding[0].changed = false;
                    filteredLactaryFeeding[0].__is_new = false;
                    localStorageEngine.save("/LactaryFeedings", filteredLactaryFeeding);
                });

            }, function() {
                localStorageEngine.save("/LactaryFeedings", filteredLactaryFeeding);
            });

            ScreenService.closePopup();
            widget.container.getWidget('widgetPopupPrescricao').view();
            deleteLactaryFeedingBackupParams(widget);
            saveProfile(widgetDetailsPatient);
        });
    }

    function setLactaryPrescriptionDefaultValues(currentRow) {

        if (!Boolean(currentRow.observacao)) {
            currentRow.observacao = "";
        }

        currentRow.unit = getLocalVar("__CDFILIAL");
        currentRow.dietName = currentRow.dietName ? currentRow.dietName : "";

    }

    function createRowToRelateLactaryFeedingToLactaryPrescription(widget, dateLactary, hourLactary) {

        var clonedLactaryPrescription = angular.copy(widget.container.getWidget('widgetPopupPrescricao').currentRow);
        var curLactaryFeeding = widget.container.getWidget('widgetPopupItemLac').currentRow;

        var lactaryFeeding = {
            "id": clonedLactaryPrescription.id,
            "serviceDate": moment(clonedLactaryPrescription.serviceDate, "YYYY-MM-DD").format("DD/MM/YYYY"),
            "unit": localStorageEngine.getLocalVar('__CDFILIAL'),
            "sequential": clonedLactaryPrescription.sequential,
            "key": Date.now(),
            "serviceId": clonedLactaryPrescription.serviceId,
            "unique": clonedLactaryPrescription.cdservfili,
            "formulationId": curLactaryFeeding.cdformulacao,
            "formulationName": curLactaryFeeding.formulationName,
            "observation": curLactaryFeeding.observation,
            "idtpservhosp": clonedLactaryPrescription.idtpservhosp,
            "plateNumbers": curLactaryFeeding.plateNumbers,
            "hourLactaryPlate": hourLactary ? moment(hourLactary, "HHmm").format("HH:mm") : moment(curLactaryFeeding.hourLactaryPlate, "HHmm").format("HH:mm"),
            "lactaryDate": dateLactary ? moment(dateLactary, "YYYY-MM-DD").format("DD/MM/YYYY") : moment(curLactaryFeeding.lactaryDate, "YYYY-MM-DD").format("DD/MM/YYYY"),
            "plateAuxId": 'P',
            "__is_new": true,
            "changed": true,
            "__isSelected": true,
            "isSelected": true,
            "DTINCLUSAO": clonedLactaryPrescription.DTINCLUSAO
        };

        return lactaryFeeding;

    }

    function saveEnteralFeeding(widget) {

        var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        if (widget.isValid()) {
            var currentRow = widget.currentRow;
            var widgetPopupPrescricao = widget.container.getWidget('widgetPopupPrescricao');
            var isAutomatic = widget.getField('automatic').value();
            if (!Boolean(currentRow.key)) {
                var rowsToSave = createRowToRelateEnteralFeedingToEnteralPrescription(widget);
                var allRowsToSave = [];
                allRowsToSave.push(rowsToSave);
                widgetDetailsPatient.localDataSourceLoaded.EnteralFeedings.unshift(rowsToSave);
                widgetDetailsPatient.curPatient.EnteralFeedings.unshift(rowsToSave);
                var backupCurrentRow = angular.copy(widget.currentRow);
                var serviceDate = moment(widgetPopupPrescricao.currentRow.serviceDate, "YYYY-MM-DD").format("DD/MM/YYYY");
                var bkpDate = widgetPopupPrescricao.currentRow.serviceDate;
                widgetPopupPrescricao.currentRow.serviceDate = serviceDate;
                widgetPopupPrescricao.getField('serviceDate').value(bkpDate);
                var time = moment(widget.currentRow.time, "HHmm").format("HH:mm");
                widget.currentRow.enteralDate = moment(widget.currentRow.enteralDate, "YYYY-MM-DD").format("DD/MM/YYYY");
                widget.currentRow.time = time;
                widgetPopupPrescricao.currentRow.feedings.unshift(rowsToSave);
                if (isAutomatic === 'S') {
                    var arrayDateEnteral = saveAutoFills(backupCurrentRow, 'enteralDate', 'time');
                    arrayDateEnteral.forEach(function(data) {
                        var obj = moment(data, "YYYY-MM-DD HHmm");
                        var dt = obj.format("YYYY-MM-DD");
                        var hr = obj.format("HHmm");
                        var rowsToSave = createRowToRelateEnteralFeedingToEnteralPrescription(widget, dt, hr);
                        allRowsToSave.push(rowsToSave);
                        widgetDetailsPatient.localDataSourceLoaded.EnteralFeedings.unshift(rowsToSave);
                        widgetDetailsPatient.curPatient.EnteralFeedings.unshift(rowsToSave);
                        var serviceDate = moment(widgetPopupPrescricao.currentRow.serviceDate, "YYYY-MM-DD").format("DD/MM/YYYY");
                        var bkpDate = widgetPopupPrescricao.currentRow.serviceDate;
                        widgetPopupPrescricao.currentRow.serviceDate = serviceDate;
                        widgetPopupPrescricao.getField('serviceDate').value(bkpDate);
                        var time = moment(widget.currentRow.time, "HHmm").format("HH:mm");
                        widget.currentRow.enteralDate = moment(widget.currentRow.enteralDate, "YYYY-MM-DD").format("DD/MM/YYYY");
                        widget.currentRow.time = time;
                        widgetPopupPrescricao.currentRow.feedings.unshift(rowsToSave);
                    });
                }
                SynchronizeService.persistOnline('/EnteralFeedings', '/EnteralFeedings/save', 'DataSet', allRowsToSave).then(function(callback) {
                    var findParams = {
                        'CDFILIAL': widgetDetailsPatient.curPatient.unit,
                        'type': 'enteralFeedings'
                    };
                    SynchronizeService.persistOnline('/EnteralFeedings', '/Structures/find', 'DataSet', [findParams]).then(function(response) {
                        response.dataset.Plates.enteralFeedings = Array.isArray(response.dataset.Plates.enteralFeedings) ? response.dataset.Plates.enteralFeedings : [];
                        localStorageEngine.setDataSource('/EnteralFeedings', response.dataset.Plates.enteralFeedings);
                        widgetDetailsPatient.localDataSourceLoaded.EnteralFeedings = angular.copy(response.dataset.Plates.enteralFeedings);
                        widgetDetailsPatient.curPatient.EnteralFeedings = response.dataset.Plates.enteralFeedings.filter(function(enteralFeeding) {
                            return enteralFeeding.id === widgetDetailsPatient.curPatient.id;
                        });
                        var datePrescription = widgetPopupPrescricao.currentRow.serviceDate;
                        var dateFormat = datePrescription.indexOf('/') > -1 ? datePrescription : moment(datePrescription).format('DD/MM/YYYY');
                        widgetPopupPrescricao.currentRow.feedings = widgetDetailsPatient.curPatient.EnteralFeedings.filter(function(enteralFeeding) {
                            return enteralFeeding.sequential === widgetPopupPrescricao.currentRow.sequential && enteralFeeding.serviceDate === dateFormat;
                        });
                    }, function() {
                        if (callback && callback.dataset && callback.dataset.error && Array.isArray(callback.dataset.error.SEQUENTIAL)) {
                            allRowsToSave.forEach(function(row, index) {
                                row.unique = callback.dataset.error.SEQUENTIAL[index];
                            });
                        }
                        MapNutritionistService.saveEnteralFeeding(allRowsToSave, false);
                    });
                }, function() {
                    MapNutritionistService.saveEnteralFeeding(allRowsToSave);
                });

            } else {
                saveEnteralFeedingEdit(widget);
                var index = widgetPopupPrescricao.currentRow.feedings.findIndex(function(feeding) {
                    return feeding.key === widget.currentRow.key;
                });
                if (widget.currentRow.preparationId === "A") {
                    widget.currentRow.preparationName = "Aberto";
                } else {
                    widget.currentRow.preparationName = "Fechado";
                }
                var enteralDate = moment(widget.currentRow.enteralDate, "YYYY-MM-DD").format("DD/MM/YYYY");
                widget.currentRow.enteralDate = enteralDate;
                widgetPopupPrescricao.currentRow.feedings[index] = widget.currentRow;
            }

            ScreenService.closePopup();
            saveProfile(widgetDetailsPatient);

        }

    }

    function saveEnteralFeedingEdit(widget) {
        var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        var widgetPopupPrescricao = widget.container.getWidget('widgetPopupPrescricao');
        if (widget.isValid()) {

            var subItemData = widget.container.getWidget('widgetPopupItemEnt').currentRow;
            var filter = [{
                name: "key",
                operator: "=",
                value: widget.currentRow.key
            }];
            var bkpIsNew;
            localStorageEngine.getDataSource("/EnteralFeedings", filter).then(function(filteredEnteralFeeding) {
                bkpIsNew = filteredEnteralFeeding[0].__is_new;
                filteredEnteralFeeding[0].changed = true;
                filteredEnteralFeeding[0].__is_new = false;
                filteredEnteralFeeding[0].plateAuxId = "P";
                filteredEnteralFeeding[0].formulationId = "";
                filteredEnteralFeeding[0].observation = subItemData.observation;
                filteredEnteralFeeding[0].serviceNumbers = subItemData.serviceNumbers;
                filteredEnteralFeeding[0].qtinfuconf = subItemData.volInfudido;
                filteredEnteralFeeding[0].plateNumbers = subItemData.volPrescription;
                filteredEnteralFeeding[0].time = moment(subItemData.time, 'HHmm').format('HH:mm');
                filteredEnteralFeeding[0].enteralDate = moment(subItemData.enteralDate).format("DD/MM/YYYY") === "Invalid date" ? subItemData.enteralDate : moment(subItemData.enteralDate).format("DD/MM/YYYY");
                filteredEnteralFeeding[0].productId = "";
                filteredEnteralFeeding[0].accessRoadId = subItemData.accessRoadId;
                filteredEnteralFeeding[0].preparationId = subItemData.preparationId;
                filteredEnteralFeeding[0].serviceDate = moment(filteredEnteralFeeding[0].serviceDate, "DD/MM/YYYY").format("DD/MM/YYYY");

                setFomulationByEnteralFeedingPreparation(subItemData.preparationId, filteredEnteralFeeding[0], subItemData.formulationId);
                SynchronizeService.persistOnline('/EnteralFeedings', '/EnteralFeedings/save', 'DataSet', filteredEnteralFeeding).then(function() {
                    var findParams = {
                        'CDFILIAL': widgetDetailsPatient.curPatient.unit,
                        'type': 'enteralFeedings'
                    };
                    SynchronizeService.persistOnline('/EnteralFeedings', '/Structures/find', 'DataSet', [findParams]).then(function(callback) {
                        callback.dataset.Plates.enteralFeedings = Array.isArray(callback.dataset.Plates.enteralFeedings) ? callback.dataset.Plates.enteralFeedings : [];
                        localStorageEngine.setDataSource('/EnteralFeedings', callback.dataset.Plates.enteralFeedings);
                        widgetDetailsPatient.localDataSourceLoaded.EnteralFeedings = angular.copy(callback.dataset.Plates.enteralFeedings);
                        widgetDetailsPatient.curPatient.EnteralFeedings = callback.dataset.Plates.enteralFeedings.filter(function(enteralFeeding) {
                            return enteralFeeding.id === widgetDetailsPatient.curPatient.id;
                        });
                        var datePrescription = widgetPopupPrescricao.currentRow.serviceDate;
                        var dateFormat = datePrescription.indexOf('/') > -1 ? datePrescription : moment(datePrescription).format('DD/MM/YYYY');
                        widgetPopupPrescricao.currentRow.feedings = widgetDetailsPatient.curPatient.EnteralFeedings.filter(function(enteralFeeding) {
                            return enteralFeeding.sequential === widgetPopupPrescricao.currentRow.sequential && enteralFeeding.serviceDate === dateFormat;
                        });
                    }, function() {
                        filteredEnteralFeeding[0].changed = false;
                        localStorageEngine.save("/EnteralFeedings", filteredEnteralFeeding);
                    });
                }, function() {
                    filteredEnteralFeeding[0].__is_new = bkpIsNew;
                    localStorageEngine.save("/EnteralFeedings", filteredEnteralFeeding);
                });

            });

        }

    }

    function createRowToRelateEnteralFeedingToEnteralPrescription(widget, dateEnteral, timeEnteral) {

        var enteralPrescription = widget.container.getWidget('widgetPopupPrescricao').currentRow;
        var subitemData = widget.currentRow;
        var serviceDate = moment(enteralPrescription.serviceDate, "YYYY-MM-DD").format("DD/MM/YYYY");
        var enteralFeeding = {
            "__is_new": true,
            "accessRoadId": subitemData.accessRoadId,
            "accessRoadName": subitemData.accessRoadName,
            "changed": true,
            "sequential": enteralPrescription.sequential,
            "key": Date.now(),
            "enteralDate": dateEnteral ? moment(dateEnteral, "YYYY-MM-DD").format("DD/MM/YYYY") : moment(subitemData.enteralDate).format("DD/MM/YYYY"),
            "formulationId": "",
            "formulationName": widget.currentRow.formulationName,
            "id": enteralPrescription.id,
            "idtpservhosp": enteralPrescription.idtpservhosp,
            "observation": subitemData.observation,
            "plateAuxId": 'P',
            "plateNumbers": subitemData.volPrescription,
            "volPrescription": subitemData.volPrescription,
            "preparationId": subitemData.preparationId,
            "productId": "",
            "qtinfuconf": subitemData.volInfudido,
            "volInfudido": subitemData.volInfudido,
            "serviceDate": serviceDate,
            "serviceNumbers": subitemData.serviceNumbers,
            "time": timeEnteral ? moment(timeEnteral, "HHmm").format("HH:mm") : moment(subitemData.time, "HHmm").format("HH:mm"),
            "unit": localStorageEngine.getLocalVar('__CDFILIAL'),
            "DTINCLUSAO": enteralPrescription.DTINCLUSAO
        };

        setFomulationByEnteralFeedingPreparation(subitemData.preparationId, enteralFeeding, subitemData.formulationId);

        return enteralFeeding;

    }

    function setFomulationByEnteralFeedingPreparation(preparationId, enteralFeeding, formulatioId) {

        if (preparationId === "A") {
            enteralFeeding.preparationName = "Aberto";
            enteralFeeding.formulationId = formulatioId;
        } else if (preparationId === "F") {
            enteralFeeding.preparationName = "Fechado";
            enteralFeeding.productId = formulatioId;
        }

    }

    function saveParenteralPrescription(widget) {

        var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        if (widget.isValid()) {
            var rowToSave = createRowToSavePrescription(widget);
            SynchronizeService.persistOnline('/ControlFeedings', '/ControlFeedings/save', 'DataSet', [rowToSave]).then(function(callback) {
                rowToSave.changed = false;
                rowToSave.__is_new = false;
                if (callback && callback.dataset && callback.dataset.error && callback.dataset.error.SEQUENTIAL) {
                    rowToSave.sequential = callback.dataset.error.SEQUENTIAL;
                }
                MapNutritionistService.savePrescription(rowToSave);
            }, function() {
                MapNutritionistService.savePrescription(rowToSave);
            });

            ScreenService.closePopup();
            widgetDetailsPatient.list();
            saveProfile(widgetDetailsPatient);
            return rowToSave;
        }
    }

    this.reloadScreenAndClearFilters = function(widget) {
        eventAggregator.publish("reloadScreenAndClearFilters", widget);
    };
    this.closeAntroAval = function(widget) {
        ScreenService.closePopup();
        widget.view();
        widget.resultadoAuth = '';
    };
    this.closeAndList = function(widget) {
        ScreenService.closePopup();
        widget.subitemtoadd = '';
        widget.infos = '';
        widget.list();
        widget.activate();
    };

    this.closePacientDetailsWidget = function(widget) {
        widget.isVisible = false;
        widget.container.showMenu = true;
        var widgetMain = widget.container.getWidget('WidgetMain');
        widgetMain.activate();
    };
    eventAggregator.subscribe('openBioEvalPopup', function(widget) {
        openBioEvalPopup(widget);
    });

    function openBioEvalPopup(widget) {
        var bioEvalPopup = widget.container.getWidget('bioEvalPopup');
        bioEvalPopup.newRow();
        bioEvalPopup.edit();
        bioEvalPopup.showAddEditBioExam = true;
        bioEvalPopup.isSubItemBeingAdded = true;
        bioEvalPopup.currentRow.__is_new = true;
        bioEvalPopup.currentRow.examinationDate = moment().format("YYYY-MM-DDTHH:mm:ss");
        if (widget.curPatient.BioEvaluations) {
            bioEvalPopup.currentRow.priority = widget.curPatient.BioEvaluations.length + 1;
        } else {
            bioEvalPopup.currentRow.priority = 1;
        }
        bioEvalPopup.getField('examinationDate').readOnly = false;
        bioEvalPopup.label = ScreenService.i18n('Nova Avaliação Bioquímica');
        reloadFields(bioEvalPopup);
        ScreenService.openPopup(bioEvalPopup);
    }
    this.closeAntroAval = function(widget) {
        ScreenService.closePopup();
        widget.view();
        widget.resultadoAuth = '';
    };

    this.addNewSubItem = function(widget) { //Sub-item
        if (widget.currentScreen === "nutriApointment") {

            widget.resultadoAuth = [];
            if (widget.subitemtoadd === 'avaliationbioq') {
                openBioEvalPopup(widget);
            }
            if (widget.subitemtoadd === 'avaliationantr') {
                var antrAvaliationPopup = widget.container.getWidget('antrAvaliationPopup');
                delete antrAvaliationPopup.fields;
                antrAvaliationPopup.fields = [];
                var fdSelected = widget.selectedRows;

                if (fdSelected && fdSelected.length > 0) {
                    var neededFields = [];
                    var methodsSelects = ['36', '40', '41', '42', '43', '51'];
                    var possibleFields = widget.localDataSourceLoaded.DataTypeEvaluations;
                    var fieldsUsedOnMethods = widget.localDataSourceLoaded.DataEvaluations;

                    fdSelected.forEach(function(fd) {
                        var mtID = fd.method;
                        fieldsUsedOnMethods.forEach(function(fum) {
                            if (fum.methodEvaluationId === mtID) {
                                neededFields.push(fum.dataEvaluationId);
                            }
                        });
                    });
                    var fieldsNeeded = [];
                    possibleFields.forEach(function(pf) {
                        neededFields.forEach(function(nf) {
                            if (nf === pf.dataTypeEvaluationId) {
                                if (fieldsNeeded.indexOf(pf) === -1) {
                                    fieldsNeeded.push(pf);
                                }
                            }
                        });
                    });

                    antrAvaliationPopup.infos = widget.infos;

                    var field = {
                        "name": "",
                        "label": "",
                        "template": "field/number.html",
                        "validations": {
                            "required": true
                        },
                        "isVisible": true,
                        "class": 6
                    };

                    fieldsNeeded.forEach(function(newField) {
                        if (methodsSelects.indexOf(newField.dataTypeEvaluationId) === -1) {
                            field.name = newField.dataTypeEvaluationId;
                            field.label = newField.dataTypeEvaluationName;
                            field.valueField = field.name;
                            var aux = metaDataFactory.fieldFactory(field, antrAvaliationPopup);
                            setFieldValue(antrAvaliationPopup, newField.dataTypeEvaluationId, aux, methodsSelects);
                            antrAvaliationPopup.fields.push(aux);
                            if (field.name === '01') {
                                antrAvaliationPopup.getField('01').setValue(getLocalVar('__appointmentdata').weight); //weight
                            } else if (field.name === '02') {
                                antrAvaliationPopup.getField('02').setValue(getLocalVar('__appointmentdata').height); //height
                            }
                        } else {
                            makeSelectField(newField, antrAvaliationPopup, methodsSelects);
                        }
                    });
                    widget.fieldsNeeded = fieldsNeeded;

                    AppointmentService.saveCheckedRows(fdSelected);
                    antrAvaliationPopup.edit();
                    antrAvaliationPopup.activate();
                    ScreenService.openPopup(antrAvaliationPopup);
                } else {
                    ScreenService.showMessage(ScreenService.i18n("Selecione algum item"));
                    widget.showAddEditAntroExam = false;
                    widget.view();
                }
            }
            if (widget.subitemtoadd === 'enteralProd') {
                widget.isSubeditting = true;
                widget.edit();
            }

        } else if (widget.currentRow.idtpservhosp === "2") {
            addLactaryFeedings(widget);
        } else if (widget.currentRow.idtpservhosp === "1") {
            addEnteralFeedings(widget);
        }
    };

    function makeSelectField(newField, widget, methodsSelects) {
        var fieldSelect = {
            "name": newField.dataTypeEvaluationId,
            "label": newField.dataTypeEvaluationName,
            "template": "tecdiet#field/select-native.html",
            "isVisible": true,
            "class": 6,
            "valueField": "value",
            "customStyle": "margin-bottom: 15px;",
            "descriptionField": "description",
            "dataSource": {
                "data": [{
                        "value": "4",
                        "description": "Seis Meses"
                    },
                    {
                        "value": "3",
                        "description": "Três Meses"
                    },
                    {
                        "value": "2",
                        "description": "Um Mês"
                    },
                    {
                        "value": "1",
                        "description": "Uma Semana"
                    }
                ]
            },
            "validations": {
                "required": true
            },
            "hideEmptyValue": true,
        };
        if (newField.dataTypeEvaluationId > '39' && newField.dataTypeEvaluationId < '44') {
            fieldSelect.dataSource.data = [{
                    "value": "1",
                    "description": "Sim"
                },
                {
                    "value": "0",
                    "description": "Não"
                }
            ];
        }
        if (newField.dataTypeEvaluationId === '51') {
            fieldSelect.dataSource.data = [{
                    "value": "4",
                    "description": "Sedentarismo (> ou = 1 e < 1,4)"
                },
                {
                    "value": "3",
                    "description": "Leve (> ou = 1,4 e < 1,6)"
                },
                {
                    "value": "2",
                    "description": "Moderado (> ou = 1,6 e < 1,9)"
                },
                {
                    "value": "1",
                    "description": "Intenso (> ou = 1,9 e < 2,5)"
                }
            ];
        }
        var aux = metaDataFactory.fieldFactory(fieldSelect, widget);
        setFieldValue(widget, newField.dataTypeEvaluationId, aux, methodsSelects);
        widget.fields.push(aux);
    }

    function configurationWidget(widget, mode) {
        Object.keys(widget[mode]).forEach(function(currentProperty) {
            var property = widget[mode][currentProperty];
            if (Array.isArray(property.fields)) {
                property.fields.forEach(function(nameField) {
                    widget.getField(nameField)[property.name] = property.value;
                });
            } else {
                Object.keys(property.fields).forEach(function(nameField) {
                    widget.getField(nameField)[property.name] = property.fields[nameField];
                });
            }
            if (typeof property.widget === "object") {
                if (property.widget.condition) {
                    if (property.widget.condition.currentRow) {
                        widget[property.name] = property.widget.condition.values[widget.currentRow[property.widget.condition.propertyWidget]];
                    } else {
                        widget[property.name] = property.widget.condition.values[widget[property.widget.condition.propertyWidget]];
                    }
                }
            }
        });
    }

    function setFieldValue(antrAvaliationPopup, id, field, methodsSelects) {
        var widget = antrAvaliationPopup.container.getWidget('WidgetDetailsPatient');
        if (widget.infos) {
            widget.infos.forEach(function(info) {
                if (info.dataTypeEvaluationId === id) {
                    if (methodsSelects.indexOf(info.dataTypeEvaluationId) !== -1) {
                        field.setValue(info.value);
                    } else {
                        field.setValue(parseFloat(info.value));
                    }
                }
            });
        }
    }

    this.changeAccessRoad = function(field) {
        field.widget.currentRow.accessRoadId = field.value();
        var accessRoad = field.dataSource.data.filter(function(access) {
            return access.accessRoadId === field.value();
        })[0];
        field.value(accessRoad.accessRoadId);
        field.widget.currentRow.accessRoadName = accessRoad.accessRoadName;
    };

    this.changeFormulation = function(field) {
        var selectedFormulation = field.dataSource.data.filter(function(formulation) {
            return formulation.formulationId === field.value();
        })[0];
        field.widget.currentRow.formulationName = selectedFormulation.formulationName;
    };

    function addEnteralFeedings(widget) {
        var widgetPopupItemEnt = widget.container.getWidget('widgetPopupItemEnt');
        widgetPopupItemEnt.newRow();
        widgetPopupItemEnt.edit();
        widgetPopupItemEnt.getField('accessRoadId').reload();
        widgetPopupItemEnt.getField('preparationId').reload();
        widgetPopupItemEnt.getField('formulationId').reload();
        widgetPopupItemEnt.getField('formulationId').disabled = true;
        widgetPopupItemEnt.getField('formulationId').readOnly = true;
        widgetPopupItemEnt.getField('automatic').isVisible = true;
        widgetPopupItemEnt.getField('period').isVisible = true;
        widgetPopupItemEnt.getField('interval').isVisible = true;
        widgetPopupItemEnt.getField('period').readOnly = true;
        widgetPopupItemEnt.getField('interval').readOnly = true;
        delete widgetPopupItemEnt.getField('interval').validations;
        delete widgetPopupItemEnt.getField('period').validations;
        configurationWidget(widgetPopupItemEnt, "modeInsert");
        ScreenService.openPopup(widgetPopupItemEnt);
    }

    eventAggregator.subscribe("disablePregnancyWeeks", function(widget) {
        disablePregnancyWeeks(widget);
    });

    function disablePregnancyWeeks(widget) {
        var status = widget.currentRow.pregnancyId;
        var pregnancyWeek = widget.getField('pregnancyWeek');
        if (status === 'S') {
            pregnancyWeek.readOnly = false;
            pregnancyWeek.validations = {
                "range": {
                    "max": 45,
                    "min": 0
                }
            };
        } else {
            pregnancyWeek.readOnly = true;
            pregnancyWeek.validations = {};
            widget.currentRow.pregnancyWeek = "";
        }
        pregnancyWeek.reload();
    }
    this.disablePregnancyWeeks = function(widget) {
        disablePregnancyWeeks(widget);
    };
    this.changeExam = function(widget) {
        eventAggregator.publish('changeSelectedExam', widget);
    };

    function addLactaryFeedings(widget) {

        widget.edit();
        setLactaryFeedingDefaultState(widget);

    }

    function setLactaryFeedingDefaultState(widget) {

        widget.currentRow.curLactaryFeeding = {};
        var widgetPopupItemLac = widget.container.getWidget('widgetPopupItemLac');
        widgetPopupItemLac.newRow();
        widgetPopupItemLac.getField('formulationId').reload();
        widgetPopupItemLac.getField('automatic').isVisible = true;
        widgetPopupItemLac.getField('period').isVisible = true;
        widgetPopupItemLac.getField('interval').isVisible = true;
        widgetPopupItemLac.getField('period').readOnly = true;
        widgetPopupItemLac.getField('interval').readOnly = true;
        delete widgetPopupItemLac.getField('interval').validations;
        delete widgetPopupItemLac.getField('period').validations;
        configurationWidget(widgetPopupItemLac, "modeInsert");
        ScreenService.openPopup(widgetPopupItemLac);
    }

    function removeDeadPatients(patientList) {
        var deadPatients = [];
        if (patientList && patientList.length > 0) {
            patientList.forEach(function(ptitem) {
                if (ptitem.isDead) {
                    deadPatients.push(patientList.indexOf(ptitem));
                }
            });
        }
        if (deadPatients && deadPatients.length > 0) {
            deadPatients.forEach(function(deadMan) {
                patientList.splice(deadMan, 1);
            });
        }
    }
    this.changePatient = function(widget, direction) {
        var widgetDetailsPatient = widget.container.getWidget('WidgetDetailsPatient');
        var filterPatient = [{
            "name": "unit",
            "operator": "=",
            "value": localStorageEngine.getLocalVar('__CDFILIAL')
        }, {
            "name": [{
                "name": "formattedName",
                "direction": "ASC"
            }],
            "operator": "ORDER_BY",
            "value": ""
        }];

        localStorageEngine.getDataSource('/Patients', filterPatient).then(function(patients) {
            var paciente = widgetDetailsPatient.curPatient;
            var curPatient;
            patients.forEach(function(a) {
                if (a.id === paciente.id) {
                    curPatient = a;
                }
            });
            var curPosition = patients.indexOf(curPatient);
            var patientsLength = patients.length;
            var nextPosition = curPosition + direction;
            removeDeadPatients(patients);

            if (patients[nextPosition] && nextPosition >= 0 && nextPosition <= patientsLength) {
                widgetDetailsPatient.curPatient = patients[nextPosition];
            } else if (nextPosition < 0) {
                nextPosition = patientsLength - 1;
                widgetDetailsPatient.curPatient = patients[nextPosition];
            } else if (nextPosition >= patientsLength) {
                nextPosition = 0;
                widgetDetailsPatient.curPatient = patients[nextPosition];
            }
            eventAggregator.publish("openPatientDetails", patients[nextPosition]);
        });
    };

    this.closePopupNewHospitalization = function(widget) {
        var fieldHall = widget.getField('hall');
        fieldHall.dataSourceFilter = [];
        fieldHall.dataSource.name = '/HallsDistincts';
        fieldHall.reload();
        ScreenService.closePopup();
    };

    eventAggregator.subscribe('sendPatientUpdate', function(patientData) {
        var widget = patientData.widget;
        var editedPatient = patientData.patient[0];
        var promise = ZHPromise.defer();
        editedPatient.situation = patientData.situation;
        editedPatient.dischargeDate = Validation.now();
        editedPatient.changed = true;
        editedPatient.newHospitalization = editedPatient.situation !== "INTERNADO" ? false : true;
        if (editedPatient.situation === 1) {
            editedPatient.isDead = true;
        }
        SynchronizeService.persistOnline('/Patients', '/Patients/save', 'DataSet', [editedPatient]).then(function() {
            editedPatient.changed = false;
        }, function() {
            editedPatient.changed = true;
            editedPatient.newHospitalization = true;
        }).finally(function() {
            promise.resolve();
        });
        promise.then(function() {
            MapNutritionistService.confirmationPatientStatus(patientData).then(function() {
                BedsService.getBed(editedPatient.bed).then(function(bedData) {
                    BedsService.changeOccupiedBedToVacate(bedData).then(function() {
                        var containerMain = widget.container;
                        containerMain.unSelectAll(widget);
                        Environment.windowReload(containerMain);
                    });
                });
            });
        });
    });

    this.directSave = function(widget) {
        var directFunctionSaveByEditing = {
            "isPatientEditing": this.savePatient,
            "isHospitalizationEditing": this.saveHospitalization
        };
        Object.keys(directFunctionSaveByEditing).forEach(function(key) {
            if (widget[key]) {
                directFunctionSaveByEditing[key].apply(null, [widget]);
            }
        });
    };

    this.maskFormat = function(field, precision, completeWith, valueBindCurrentRow) {
        if (field, typeof precision === 'number', typeof completeWith === 'string') {
            if (!isNaN(field.value())) {
                var value = String(field.value()).padStart(precision, completeWith);
                field.value(value);
                var valueBind = valueBindCurrentRow || field.valueField || field.name;
                field.widget.currentRow[valueBind] = value;
            }
        }
    };
    this.verifyAdjusts = function(field, precision, completeWith) {
        var adjusts = getLocalVar("__ISAJUSTA");
        if (adjusts === 'S') {
            this.maskFormat(field, precision, completeWith);
        }
    };

    this.savePatient = function(widget) {
        if (widget.isValid()) {
            var currentRow = widget.currentRow;
            if (isValidPatientData(currentRow)) {
                var rowToSave = createRowToSavePatient(currentRow);
                rowToSave.patientSequentialCode = getLocalVar("__ISSEQUENTIAL");
                rowToSave.patientAjusta = getLocalVar("__ISAJUSTA");
                restEngine.post('/Patients/save', {
                    "requestType": "DataSet",
                    "dataset": [rowToSave]
                }).then(function(callback) {
                    var msg;
                    if (callback.dataset && callback.dataset.error && Array.isArray(callback.dataset.error.ERROR) && callback.dataset.error.ERROR[0] && callback.dataset.error.ERROR[0].indexOf('ORA-00001') !== -1) {
                        msg = ScreenService.i18n('Já existe um paciente cadastrado com este código!');
                        ScreenService.showMessage(msg);
                    } else {
                        localStorageEngine.save('/Profiles', {
                            'confidentiality': null,
                            'eatingHabits': "",
                            'foodIntolerance': "",
                            'id': rowToSave.id,
                            'observation': null,
                            'unit': rowToSave.unit
                        }).then(function() {
                            rowToSave.__is_new = false;
                            rowToSave.changed = false;
                            rowToSave.dischargeDate = null;
                            MapNutritionistService.savePatient(rowToSave).then(function() {
                                widget.container.getWidget('WidgetMain').reload();
                            });
                            widget.container.getWidget('WidgetMain').reload();
                            ScreenService.closePopup();
                            widget.container.getWidget('WidgetMain').reload();
                            msg = ScreenService.i18n('Paciente cadastrado com sucesso!');
                            ScreenService.showMessage(msg, 'success');
                        });
                    }
                }, function() {
                    var msg = ScreenService.i18n('Não foi possível conectar ao servidor, tente novamente mais tarde.');
                    ScreenService.showMessage(msg);
                });
            }
        }
    };

    function isValidPatientData(currentRow) {
        var dataNascimento = moment(currentRow.birthDate, "YYYY-MM-DD");
        var date = moment().diff(dataNascimento, 'days');
        if (date < 0) {
            ScreenService.showMessage(ScreenService.i18n("Data de nascimento inválida!"));
            return false;
        }
        date = moment().diff(dataNascimento, 'years');
        if (date > 130) {
            ScreenService.showMessage(ScreenService.i18n("Data de nascimento inválida!"));
            return false;
        }
        if (dataNascimento > moment()) {
            ScreenService.showMessage(ScreenService.i18n("Data de nascimento inválida!"));
            return false;
        }
        return true;
    }
    var getAge = function(dateOfBirth, format, typeReturn) {
        var dateBirth = moment(dateOfBirth, format);
        if (dateBirth.isValid()) {
            var dateDefault = moment(dateOfBirth, format).format('YYYY-MM-DD');
            var years = moment().diff(dateDefault, 'years');
            var months = moment().diff(dateDefault, 'month');
            var decimalMonths = moment().diff(dateDefault, 'month', true) - Math.trunc(moment().diff(dateDefault, 'month', true));
            if (decimalMonths >= 0.5) {
                months++;
            }
            var monthBirth = months - (years * 12);
            switch (typeReturn) {
                case 'years':
                    return years;
                case 'months':
                    return months;
                case 'full':
                    return {
                        '0': years,
                        '1': monthBirth
                    };
                default:
                    return null;
            }
        }
    };

    function createRowToSavePatient(patientInfos) {
        var yearAndMonth = getAge(patientInfos.birthDate, "YYYY-MM-DD", "full");

        var rowToSave = {
            "organizationNumber": localStorageEngine.getLocalVar("__NRORGTRAB"),
            "unit": localStorageEngine.getLocalVar("__CDFILIAL"),
            "id": patientInfos.id,
            "name": patientInfos.name,
            "age": patientInfos.age,
            "idnamepaci": patientInfos.id + ' - ' + patientInfos.name + ' ' + patientInfos.lastName.toUpperCase(),
            "normalizedName": removerAcentos(patientInfos.name + ' ' + patientInfos.lastName.toUpperCase()),
            "yearAndMonth": yearAndMonth,
            "formattedName": patientInfos.name + ' ' + patientInfos.lastName.toUpperCase(),
            "lastName": patientInfos.lastName,
            "birthDate": moment(patientInfos.birthDate, "YYYY-MM-DD").format("DD/MM/YYYY"),
            "gender": patientInfos.gender,
            "situation": null,
            "__is_new": true,
            "changed": true

        };

        return rowToSave;

    }

    function removerAcentos(newStringComAcento) {
        var string = newStringComAcento;
        var mapaAcentosHex = {
            a: /[\xE0-\xE6]/g,
            A: /[\xC0-\xC6]/g,
            e: /[\xE8-\xEB]/g,
            E: /[\xC8-\xCB]/g,
            i: /[\xEC-\xEF]/g,
            I: /[\xCC-\xCF]/g,
            o: /[\xF2-\xF6]/g,
            O: /[\xD2-\xD6]/g,
            u: /[\xF9-\xFC]/g,
            U: /[\xD9-\xDC]/g,
            c: /\xE7/g,
            C: /\xC7/g,
            n: /\xF1/g,
            N: /\xD1/g
        };

        for (var letra in mapaAcentosHex) {
            var expressaoRegular = mapaAcentosHex[letra];
            string = string.replace(expressaoRegular, letra);
        }

        return string;
    }

    this.setPatientAge = function(patientWidget) {
        var data = moment(patientWidget.currentRow.birthDate, "YYYY-MM-DD");
        if (data._i) {
            var years = moment().diff(data, 'years');
            if (years < 0) {
                years = 0;
            }
            patientWidget.currentRow.age = years;
            var yearAndMonth = getAge(data, "YYYY-MM-DD", "full");
            var idade;
            if (yearAndMonth[0] === 0) {
                idade = yearAndMonth[1] + ' Meses';
            } else if (yearAndMonth[1] === 0) {
                idade = yearAndMonth[0] + ' Anos';
            } else {
                idade = yearAndMonth[0] + ' Anos e ' + yearAndMonth[1] + ' Meses';
            }
            patientWidget.currentRow.yearAndMonth = idade;
        }
    };

    this.saveHospitalization = function(widget) {
        var fieldEdited = widget.currentRow;
        var promise = ZHPromise.defer();
        if (isValidHospitalization(widget)) {
            if (isValidDate(widget)) {
                createRowToHospitalization(fieldEdited).then(function(rowToSave) {
                    SynchronizeService.persistOnline('/Patients', '/Patients/save', 'DataSet', [rowToSave]).then(function() {
                        rowToSave.changed = false;
                        rowToSave.newHospitalization = false;
                    }).finally(function() {
                        promise.resolve();
                    });
                    promise.then(function() {
                        MapNutritionistService.savePatient(rowToSave).then(function() {
                            widget.reload().then(function() {
                                var fieldHall = widget.getField('hall');
                                fieldHall.dataSource.name = '/HallsDistincts';
                                fieldHall.dataSourceFilter = [];
                                fieldHall.reload();
                                ScreenService.closePopup();
                                widget.container.getWidget('WidgetMain').reload();
                                BedsService.getBed(rowToSave.bed).then(function(vacantBedToOccupy) {
                                    BedsService.changeVacantBedToOccupied(vacantBedToOccupy).then(function() {
                                        self.onEnterWidgetMain(widget);
                                    }, function() {
                                        ScreenService.showMessage(ScreenService.i18n("Não foi possível internar o paciente. Tente novamente"), 'error');
                                    });
                                });
                            });
                        });
                        widget.isHospitalizationEditing = false;
                        widget.list();

                    });
                }, function(error) {
                    ScreenService.showMessage(ScreenService.i18n(error), 'error');
                });
            }
        }
    };

    function isValidDate(widget) {
        var row = angular.copy(widget.currentRow);
        //var date = moment(, "YYYY-MM-DDTHH:mm").format("YYYY-MM-DD");

        if (moment(row.hospitalizationDate, 'YYYY-MM-DDTHH:mm') > moment()) {
            ScreenService.showMessage(ScreenService.i18n('A data informada deve ser menor ou igual a data atual.'));
            return false;
        } else {
            return true;
        }
    }

    function isValidHospitalization(widget) {
        return widget.isValid();
    }

    function createRowToHospitalization(field) {
        var deferred = ZHPromise.defer();
        var rowToHospitalization;
        MapNutritionistService.getPatientById(field.id).then(function(patient) {
            var filter = [{
                "name": "bed",
                "operator": "=",
                "value": field.bed
            }];
            rowToHospitalization = angular.copy(patient);
            localStorageEngine.getDataSource("/BedsPrescriptions", filter).then(function(beds) {
                if (beds && beds.length) {
                    rowToHospitalization = Object.assign(rowToHospitalization, beds[0]);
                }
                rowToHospitalization.lastVisit = null;
                rowToHospitalization.medicalTeamId = field.medicalTeamId;
                rowToHospitalization.newHospitalization = true;
                rowToHospitalization.changed = true;
                rowToHospitalization.healthInsuranceId = field.hospitalizationPattern;
                rowToHospitalization.hospitalization = moment(field.hospitalizationDate, "YYYY-MM-DDTHH:mm").format("DD/MM/YYYY HH:mm");
                rowToHospitalization.situation = "INTERNADO";
                rowToHospitalization.id = patient.id;
                rowToHospitalization.DTINCLUSAO = moment().format("DD/MM/YYYY HH:mm:ss");
                rowToHospitalization.DTULTATU = moment().format("DD/MM/YYYY HH:mm:ss");
                rowToHospitalization.CDOPERINCLUSAO = getLocalVar('__CDOPERADOR');
                rowToHospitalization.CDOPERULTATU = getLocalVar('__CDOPERADOR');
                rowToHospitalization.__is_new = patient.__is_new;
                rowToHospitalization.organizationNumber = getLocalVar("__NRORGTRAB");
                deferred.resolve(rowToHospitalization);
            });
        }, function(error) {
            deferred.reject(error);
        });
        return deferred.promise;
    }

    this.onEnterWidgetMain = function(widget) {
        getBedsPrescriptions(widget);
        getNonHospitalizedPatients(widget);
        getMedicalTeam(widget);

        var filter = [{
                name: [{
                    name: "formattedName",
                    direction: "ASC"
                }],
                operator: "ORDER_BY",
                value: ""
            },
            {
                name: "unit",
                operator: "=",
                value: getLocalVar("__CDFILIAL")
            }
        ];
        widget.reload(filter);
    };

    function getBedsPrescriptions(widget) {

        var filter = [{
            name: [{
                name: "bed",
                direction: "ASC"
            }],
            operator: "ORDER_BY",
            value: ""
        }];

        return localStorageEngine.getDataSource("/BedsPrescriptions", filter).then(function(bedsPrescriptions) {
            widget.BedsPrescriptions = bedsPrescriptions;
        });

    }

    function getNonHospitalizedPatients(widget) {

        var filter = [{
            name: "bed",
            operator: "IS_NULL",
            value: ""
        }, {
            name: [{
                    name: "id",
                    direction: "ASC"
                },
                {
                    name: "name",
                    direction: "ASC"
                }
            ],
            operator: "ORDER_BY",
            value: ""
        }];

        return localStorageEngine.getDataSource("/Patients", filter).then(function(nonHospitalizedPatients) {
            widget.NonHospitalizedPatients = nonHospitalizedPatients;
        });
    }

    function reloadFields(widget) {
        widget.fields.forEach(function(field) {
            if (field.dataSource) {
                field.reload([{
                    "name": [{
                        "name": field.descriptionField,
                        "direction": "ASC"
                    }],
                    "operator": "ORDER_BY",
                    "value": ""
                }]);
            }
        });
    }

    function getMedicalTeam(widget) {
        return localStorageEngine.getDataSource("/MedicalTeams", null).then(function(medicalTeam) {
            widget.MedicalTeam = medicalTeam;
        });
    }

    function clearDependentFields(parentField) {
        var dependentFieldsNames = parentField.dependentFields || [];
        dependentFieldsNames = Array.isArray(dependentFieldsNames) ? dependentFieldsNames : [dependentFieldsNames];
        dependentFieldsNames.forEach(function(dependentFieldName) {
            var dependentField = parentField.widget.getField(dependentFieldName);
            dependentField.setValue("");
            dependentField.clearValue();
            clearDependentFields(dependentField);
        });
    }

    this.onChangeFoodControlService = function(widget) {
        widget.redraw();
        var idformdiet = { //Diet
            '0': ['0', '3', '4'], //'NORMAL', 'ROOM SERVICE', 'ESPECIAL'
            '2': '1', //'LACTARIO',
            '1': '2' //'ENTERAL',
        };
        var currentRow = widget.currentRow;
        var fieldService = widget.getField('serviceId');
        var service = fieldService.dataSource.data.filter(function(service) {
            return service.serviceId === widget.currentRow.serviceId;
        })[0];

        clearDependentFields(fieldService);
        var fieldDiet = widget.getField('dietId');
        fieldDiet.readOnly = false;
        currentRow.serviceId = service.serviceId;
        currentRow.serviceName = service.serviceName;
        currentRow.idtpservhosp = service.service;
        currentRow.unit = service.unit;
        currentRow.selectedDiet = {};
        currentRow.dietId = "";
        currentRow.dietTypeName = "";
        currentRow.dietService = "";
        widget.filtredFeedingForWidget = [];
        widget.filtredFeedingsForWidget = [];

        fieldDiet.dataSourceFilter.forEach(function(currentFilter) {
            if (currentFilter.name === "service") {
                currentFilter.value = idformdiet[currentRow.idtpservhosp];
                if (currentRow.idtpservhosp === "0" || !currentRow.idtpservhosp) {
                    currentFilter.operator = "IN";
                    currentFilter.value = currentFilter.value || ['0', '3', '4'];
                }

            } else {
                currentFilter.value = currentRow[currentFilter.name];
            }
        });

        fieldDiet.reload();
    };
    eventAggregator.subscribe("updateDietFromPrescriptionDiet", function(widgetPopupPrescricao) {
        changeFoodControlDiet(widgetPopupPrescricao, true);
    });

    this.onChangeFoodControlDiet = function(widget, changedDatePrescription) {
        var fieldDate = widget.getField('serviceDate');
        var date = changedDatePrescription === true && fieldDate ? moment(fieldDate.value(), 'YYY-MM-DD') : false;
        if ((changedDatePrescription === true && widget.currentRow.typeClicked === 'oral' && date && date.isValid() && widget.currentRow.dietService !== '4' && widget.currentRow.idformdiet !== '4') || !changedDatePrescription) {
            changeFoodControlDiet(widget);
        }
    };

    function changeFoodControlDiet(widget) {

        var tipodeservico = {
            '0': 'NORMAL',
            '1': 'LACTARIO',
            '2': 'ENTERAL',
            '3': 'ROOM SERVICE',
            '4': 'ESPECIAL'
        };

        var currentRow = widget.currentRow;
        var selectDiet = widget.getField('dietId').dataSource.data.filter(function(currentDiet) {
            return currentDiet.dietId === widget.getField('dietId').value();
        })[0];

        if (selectDiet) {
            currentRow.dietService = selectDiet.service;
            currentRow.dietId = selectDiet.dietId;
            currentRow.dietName = selectDiet.dietName;
            currentRow.dietTypeName = tipodeservico[selectDiet.service];
            currentRow.dietGroup = selectDiet.dietGroup;
        }
        var curDate = currentRow.serviceDate;
        var dateEdited = moment(curDate, 'YYYY-MM-DD').format('DD/MM/YYYY');
        curDate = dateEdited === "Invalid date" ? curDate : dateEdited;
        curDate = moment(curDate, "DD/MM/YYYY").format("DD/MM/YYYY");
        var cdfilial = localStorageEngine.getLocalVar('__CDFILIAL');
        var filter = [{
            "name": "dtCard",
            "operator": "=",
            "value": curDate
        }, {
            "name": "unit",
            "operator": "=",
            "value": cdfilial
        }];

        if (currentRow.idtpservhosp !== "2") { //Não for lactario
            filter.push({
                "name": "dietid",
                "operator": "=",
                "value": currentRow.dietId
            }, {
                "name": "cdservfili",
                "operator": "=",
                "value": currentRow.serviceId
            }, {
                "name": [{
                    "name": "NRORDPRATCAR",
                    "direction": "ASC"
                }],
                "operator": "ORDER_BY",
                "value": ""
            });
            widget.filtredFeedingsForWidget = [];
            if (selectDiet) {
                if (selectDiet.idtpservhosp !== "4" && currentRow.dietService !== '4') {
                    localStorageEngine.getDataSource('/Plates', filter).then(function(platesByDiet) {
                        var filteredPlates = platesByDiet;
                        var promisePlates = ZHPromise.defer();
                        if (!platesByDiet.length) {
                            var newFilter = [];
                            filter.forEach(function(cFilter) {
                                if (cFilter.name !== 'dietid') {
                                    newFilter.push(cFilter);
                                }
                            });
                            localStorageEngine.getDataSource('/PlatesPla', newFilter).then(function(platesPla) {
                                filteredPlates = platesPla;
                                promisePlates.resolve();
                            });
                        } else {
                            promisePlates.resolve();
                        }
                        promisePlates.then(function() {
                            filteredPlates.forEach(function(fe) {
                                fe.selectedByUser = fe.isRequiredOnMenu;
                                fe.plateType = fe.isRequiredOnMenu ? fe.plateType : fe.plateType + ' (' + ScreenService.i18n('Opção') + ')';
                                fe.idopcaoconf = fe.isRequiredOnMenu ? fe.idopcaoconf = 'N' : fe.idopcaoconf = 'S';
                            });
                            var arrayFinal = [];
                            filteredPlates.reduce(function(prev, current) {
                                var index = prev.findIndex(function(j) {
                                    return j.plateType === current.plateType;
                                });
                                if (index < 0) {
                                    index = prev.length;
                                    prev.push({
                                        plateType: current.plateType,
                                        lista: []
                                    });
                                }
                                prev[index].lista.push(current);
                                return prev;
                            }, []).map(function(item) {
                                return item.lista;
                            }).forEach(function(it) {
                                if (it.length === 0) {
                                    it.isFirst = true;
                                    arrayFinal.push(it);
                                } else {
                                    for (var i = 0; i < it.length; i++) {
                                        if (i === 0) {
                                            it[i].isFirst = true;
                                        }
                                        arrayFinal.push(it[i]);
                                    }
                                }
                            });
                            widget.filtredFeedingsForWidget = arrayFinal;
                        });
                    });
                } else {
                    widget.openPopup = false;
                    loadDataPopupPlates(widget);
                }
            }
        }
    }
    eventAggregator.subscribe('loadDataPlatesByUnit', function(widget) {
        loadDataPopupPlates(widget);
    });

    function loadDataPopupPlates(widget) {
        var widgetPopupPlates = widget.container.getWidget('widgetPopupPlates');
        widgetPopupPlates.allFieldsAreSelected = false;
        widgetPopupPlates.selectedRows = [];
        var widgetPrescricao = widget.container.getWidget('widgetPopupPrescricao');
        var filter = [{
            "name": "cdservfili",
            "operator": "=",
            "value": widgetPrescricao.currentRow.serviceId
        }];
        localStorageEngine.getDataSource('/PlatesByUnit', filter).then(function(dataSource) {
            var dataSourceName = widgetPopupPlates.descriptionPopupSelect.dataSourceName;
            widgetPopupPlates[dataSourceName] = angular.copy(dataSource);
            widgetPopupPlates.elementsToSearch = angular.copy(dataSource);
            widgetPopupPlates.elementsToBind = widgetPopupPlates.elementsToSearch.reduce(function(prev, current) {
                var index = prev.findIndex(function(j) {
                    return j.plateType === current.plateType;
                });
                if (index < 0) {
                    index = prev.length;
                    prev.push({
                        plateType: current.plateType,
                        lista: []
                    });
                }
                prev[index].lista.push(current);
                return prev;
            }, []).map(function(item) {
                item.lista.opened = false;
                return item.lista;
            });
            widgetPopupPlates.platesToSearch = angular.copy(dataSource);

            if (widgetPrescricao.filtredFeedingsForWidget && widgetPrescricao.filtredFeedingsForWidget.length) {
                widgetPrescricao.filtredFeedingsForWidget.forEach(function(feeding) {
                    var foundedPlates = widgetPopupPlates.elementsToSearch.filter(function(plate) {
                        return plate.formulationId === feeding.formulationId &&
                            plate.plateType === feeding.plateType;
                    });
                    var selectedPlate = foundedPlates[0];
                    if (selectedPlate) {
                        if (Array.isArray(widgetPopupPlates.selectedRows) && widgetPopupPlates.selectedRows.length) {
                            var row = widgetPopupPlates.selectedRows.filter(function(rowToSelect) {
                                return rowToSelect.formulationId === selectedPlate.formulationId && rowToSelect.plateType === selectedPlate.plateType;
                            })[0];
                            if (!row) {
                                widgetPopupPlates.selectedRows.push(selectedPlate);
                            }
                            selectedPlate.selectedRow = row ? row.selectedRow : true;
                        } else {
                            selectedPlate.selectedRow = true;
                            widgetPopupPlates.selectedRows.push(selectedPlate);
                        }
                    }
                });
                if (widgetPrescricao.filtredFeedingsForWidget.length === widgetPopupPlates.elementsToSearch.length) {
                    widgetPopupPlates.allFieldsAreSelected = true;
                } else {
                    widgetPopupPlates.allFieldsAreSelected = false;
                }
                widgetPopupPlates.backupSelectedRows = angular.copy(widgetPopupPlates[dataSourceName].filter(function(plate) {
                    return plate.selectedRow;
                }));
                widget.elementsToBind.forEach(function(parent) {
                    if (widget.allFieldsAreSelected) {
                        parent.selectedParent = true;
                        parent.opened = true;
                    } else {
                        var isSelected = true;
                        parent.forEach(function(filho) {
                            if (!filho.selectedRow) {
                                isSelected = false;
                            } else {
                                parent.opened = true;
                            }
                        });
                        parent.selectedParent = isSelected;
                    }
                });
            } else {
                widgetPopupPlates.selectedRows = [];
            }
            if (widget.openPopup) {
                ScreenService.openPopup(widget);
            }
        });
    }

    this.selectPlatesOnPopup = function(widget) {
        var popupPrescricaoOral = widget.container.getWidget('widgetPopupPrescricao');
        widget.container.getWidget('widgetPopupPlates').isVisible = false;
        ScreenService.closePopup();
        widget.descriptionPopupSelect.search = "";
        var selectedRows = [];
        widget.selectedRows.forEach(function(rowSelected) {
            var index = popupPrescricaoOral.filtredFeedingsForWidget.findIndex(function(feeding) {
                return feeding.formulationId === rowSelected.formulationId && feeding.plateType === rowSelected.plateType;
            });
            if (index > -1) {
                selectedRows.push(popupPrescricaoOral.filtredFeedingsForWidget[index]);
            } else {
                selectedRows.push(rowSelected);
            }

        });
        var arrayFinal = [];
        selectedRows.reduce(function(prev, current) {
            var index = prev.findIndex(function(j) {
                return j.plateType === current.plateType;
            });
            if (index < 0) {
                index = prev.length;
                prev.push({
                    plateType: current.plateType,
                    lista: []
                });
            }
            prev[index].lista.push(current);
            return prev;
        }, []).map(function(item) {
            return item.lista;
        }).forEach(function(it) {
            if (it.length === 0) {
                it.isFirst = true;
                arrayFinal.push(it);
            } else {
                for (var i = 0; i < it.length; i++) {
                    if (i === 0) {
                        it[i].isFirst = true;
                    }
                    arrayFinal.push(it[i]);
                }
            }
        });
        popupPrescricaoOral.filtredFeedingsForWidget = angular.copy(arrayFinal);

    };

    this.returnBackUpRowPopup = function(widget, namePopup) {
        var widgetPopup;
        if (typeof namePopup === 'string') {
            widgetPopup = widget.container.getWidget(namePopup);
        } else {
            widgetPopup = widget.container.getWidget('widgetPopupPlates');
        }
        widgetPopup.isVisible = false;
        widgetPopup.selectedRows = widgetPopup.backupSelectedRows ? angular.copy(widgetPopup.backupSelectedRows) : [];
        widget.descriptionPopupSelect.search = "";
        widget.search = "";
        ScreenService.closePopup();
    };

    this.returnBackUpRowPopupFormulationLact = function(widget) {
        widget.isVisible = false;
        widget.descriptionPopupSelect.search = "";
        if (widget.dataSourceFilter) {
            widget.dataSourceFilter.forEach(function(filter) {
                if (filter.operator === 'LIKE' || filter.operator === 'LIKE_I') {
                    filter.value = "%%";
                } else {
                    filter.value = "";
                }
            });
        }
        ScreenService.closePopup();
    };

    this.onChangeFormulation = function(fieldFormulation) {
        var widgetPopupItemLac = fieldFormulation.widget;
        var formulation = fieldFormulation.dataSource.getCheckedRows()[0];
        if (formulation) {
            widgetPopupItemLac.getField('un').value(formulation.un);
            widgetPopupItemLac.currentRow.formulationName = formulation.nmformulacao;
            widgetPopupItemLac.currentRow.formulationId = formulation.cdformulacao;
            fieldFormulation.value(formulation.nmformulacao);
        } else {
            widgetPopupItemLac.getField('un').value("");
            widgetPopupItemLac.currentRow.formulationName = "";
            widgetPopupItemLac.currentRow.formulationId = "";
            fieldFormulation.value("");
        }

    };

    this.storeyOnChange = function(widget) {
        widget.redraw();
        var bedField = widget.getField('bed');
        var hallField = widget.getField('hall');
        setTimeout(function() {
            widget.currentRow.hall = '';
            widget.currentRow.bed = '';

            if (widget.currentRow.storey) {
                hallField.dataSource.name = "/Halls";
                bedField.dataSourceFilter = [{
                        "name": "storey",
                        "operator": "=",
                        "value": widget.currentRow.storey
                    },
                    {
                        "name": "unit",
                        "operator": "=",
                        "value": getLocalVar('__CDFILIAL')
                    }
                ];
                hallField.dataSourceFilter = [{
                        "name": "storey",
                        "operator": "=",
                        "value": widget.currentRow.storey
                    },
                    {
                        "name": "unit",
                        "operator": "=",
                        "value": getLocalVar('__CDFILIAL')
                    }
                ];
            } else {
                hallField.dataSourceFilter = [];
                hallField.dataSource.name = "/HallsDistincts";
                bedField.dataSourceFilter = [{
                    "name": "unit",
                    "operator": "=",
                    "value": getLocalVar('__CDFILIAL')
                }];
            }
            bedField.reload();
            hallField.reload();
        }, 200);
    };

    this.hallOnChange = function(widget) {
        widget.redraw();
        var bedField = widget.getField('bed');
        widget.currentRow.bed = '';

        if (widget.currentRow.hall) {

            bedField.dataSourceFilter = [{
                    "name": "hall",
                    "operator": "=",
                    "value": widget.currentRow.hall
                },
                {
                    "name": "unit",
                    "operator": "=",
                    "value": getLocalVar('__CDFILIAL')
                }
            ];
            if (widget.currentRow.storey) {
                bedField.dataSourceFilter.push({
                    "name": "storey",
                    "operator": "=",
                    "value": widget.currentRow.storey
                });
            }
        } else {
            var has = false;

            bedField.dataSourceFilter.forEach(function(filtro) {
                if (filtro.name === "hall") {
                    has = true;
                }
            });
            if (has) {
                bedField.dataSourceFilter.splice(
                    bedField.dataSourceFilter.indexOf(
                        bedField.dataSourceFilter.filter(function(index) {
                            return index.name === "hall";
                        })[0]),
                    1);
            }
        }
        bedField.reload();
    };

    this.bedOnChange = function(widget) {
        if (widget.currentRow.bed) {
            var field = widget.getField('bed');
            var bed = field.dataSource.data.filter(function(filtro) {
                return filtro.bed === field.widget.currentRow.bed;
            })[0];
            widget.currentRow.hall = bed.hall;
            widget.currentRow.storey = bed.storey;
        }
    };

    this.controlAutoFills = function(widget) {
        var isAutomatic = widget.getField('automatic').value();
        var interval = widget.getField('interval');
        var period = widget.getField('period');
        var validationsIntervalExists = interval.validations;
        var validationsPeriodExists = interval.validations;
        if (widget) {
            if (isAutomatic === 'S') {
                interval.readOnly = false;
                period.readOnly = false;
                interval.validations = {
                    "required": true
                };
                period.validations = {
                    "required": true
                };
            } else {
                interval.clearValue();
                period.clearValue();
                interval.readOnly = true;
                period.readOnly = true;
                if (validationsIntervalExists && validationsPeriodExists) {
                    delete interval.validations.required;
                    delete period.validations.required;
                }
            }
        }
    };

    function saveAutoFills(currentRow, fieldDate, fieldHour) {
        var dateTimeInitial = moment(currentRow[fieldDate] + " " + currentRow[fieldHour], "YYYY-MM-DD HHmm");
        var dateTimeFeeding = moment(currentRow[fieldDate] + " " + currentRow[fieldHour], "YYYY-MM-DD HHmm");
        var period = currentRow.period;
        var interval = moment(currentRow.interval, "HHmm");
        var arrayDate = [];
        var periodOfMinutes = (parseInt(period.split(':')[0]) * 60) + parseInt(period.split(':')[1]);
        while (dateTimeFeeding.diff(dateTimeInitial, 'minutes') < periodOfMinutes) {
            dateTimeFeeding.add('m', interval.format('mm')).add('h', interval.format('HH'));
            if (dateTimeFeeding.diff(dateTimeInitial, 'minutes') <= periodOfMinutes) {
                arrayDate.push(dateTimeFeeding.format('YYYY-MM-DD HHmm'));
            }
        }
        return arrayDate;
    }

    function checkNutritionist() {
        localStorageEngine.getDataSource('/nutritionist').then(function(nutritionist) {
            if (nutritionist.length === 0) {
                ScreenService.showMessage(ScreenService.i18n('O operador não possui acesso à essa tela, pois não está cadastrado como nutricionista.'), 'error').then(function() {
                    ScreenService.openWindow('MapKitchenMaid');
                });
            }
        });
    }
};

Configuration(function(ContextRegister) {
    ContextRegister.register('MapNutritionistController', MapNutritionistController);
});
