var ControlFeedingService = function(localStorageEngine, EnteralFeedingsRepository, LactaryFeedingsRepository, NormalFeedingsRepository, ZHPromise, Validation) {

    var SERVICES = {
        NORMAL: "0",
        LACTARY: "1",
        ENTERAL: "2",
        ROOM_SERVICE: "3",
        ESPECIAL: "4"
    };

    this.save = function(currentRow) {

        if (currentRow.serviceId === SERVICES.ENTERAL) {
            return EnteralFeedingsRepository.save(currentRow);
        }

        if (currentRow.serviceId === SERVICES.LACTARY) {
            return LactaryFeedingsRepository.save(currentRow);
        }

        if (currentRow.service === SERVICES.NORMAL || currentRow.serviceId === SERVICES.NORMAL) {
            return NormalFeedingsRepository.save(currentRow);
        }

    };

    this.saveCheckedRowsNormal = function(checkedRows) {
        return localStorageEngine.save('/NormalFeedings', checkedRows);
    };

    this.saveCheckedRows = function(checkedRows) {

        var rows = [];

        checkedRows.map(function(checkedRow) {

            if (checkedRow.__isSelected === undefined) {
                checkedRow.__isSelected = false;
            }

            rows.push(checkedRow);

        });

        var count = 0;

        var save = function() {

            if (count < rows.length) {

                return NormalFeedingsRepository.save(rows[count]).then(function() {
                    count++;
                    return save();
                });

            }

        };

        return ZHPromise.all(rows).then(function() {
            return save();
        });

    };

    this.saveControlFeeding = function(widget, isNew) {
        var currentRow;
        if (!isNew) {
            currentRow = angular.copy(widget.container.getWidget('WidgetControlFeeding').currentRow);
        } else {
            currentRow = widget.currentRow;
        }

        var now = new Date();
        var key = now.getTime();
        var serviceId = '';
        var serviceName = '';
        if (currentRow.service === SERVICES.LACTARY) {
            serviceId = SERVICES.ENTERAL;
            serviceName = "ENTERAL";
        }

        if (currentRow.service === SERVICES.ENTERAL) {
            serviceId = SERVICES.LACTARY;

            serviceName = "LACTARIO";
        }

        if ((currentRow.service === SERVICES.NORMAL) || (currentRow.serviceId === SERVICES.NORMAL)) {
            serviceId = SERVICES.NORMAL;
            serviceName = "NORMAL";

            var objects = [];
            var unique = 0;
            var rows = angular.element('#footer').scope().templateManager.container.getWidget('WidgetNormalFeedingSwipe').dataSource.data;

            if (currentRow.__is_new) {
                rows.forEach(function(row) {

                    if (row.__isSelected === undefined) {
                        row.__isSelected = false;
                    }

                    unique++;
                    var key = rows.length + 1;

                    objects.push({
                        "id": localStorageEngine.getLocalVar('__patient'),
                        "unit": row.unit,
                        "serviceId": currentRow.serviceId,
                        "key": key,
                        "unique": Validation.strPad(unique, 4),
                        "plateName": row.plateName,
                        "plateTypeName": row.plateTypeName,
                        "serviceDate": currentRow.date,
                        "plateNumbers": "1",
                        "plateAuxId": row.plateAuxId,
                        "formulationId": row.formulationId,
                        "observation": null,
                        "dietId": currentRow.dietId,
                        "changed": true,
                        "__isSelected": row.__isSelected,
                        "isSelected": row.__isSelected
                    });

                });

                this.saveCheckedRowsNormal(objects);
            } else {
                rows.forEach(function(row) {

                    if (row.__isSelected === true) {
                        row.isSelected = true;
                    }
                    row.changed = true;

                });

                return this.saveCheckedRowsNormal(rows);
            }

        }

        if (currentRow.__is_new) {
            var obj = {
                __is_new: true,
                changed: true,
                dietName: currentRow.dietName,
                dietId: currentRow.dietId,
                id: localStorageEngine.getLocalVar('__patient'),
                sequential: key,
                service: currentRow.serviceName,
                serviceDate: currentRow.date,
                dietGroup: currentRow.dietGroup,
                serviceId: serviceId,
                serviceCode: currentRow.serviceId,
                serviceName: serviceName,
                unit: localStorageEngine.getLocalVar('__CDFILIAL'),
                nutritionist: localStorageEngine.getLocalVar('__CDOPERADOR'),
                hospitalization: localStorageEngine.getLocalVar('__hospitalization')
            };
            isNew = false;
            return localStorageEngine.save('/ControlFeedings', obj);
        }
    };

};
Configuration(function(ContextRegister) {
    ContextRegister.register('ControlFeedingService', ControlFeedingService);
});
