function HistoryAvaliationsController(ApplicationContext, templateManager, ScreenService, eventAggregator, localStorageEngine) {
    
    this.openPopup = function(historyAvaliations){
        var appointment = getLocalVar('__appointmentdata');
        var filterPatient = [{
            name: "id",
            operator: "=",
            value: historyAvaliations.container.getWidget('WidgetDetailsPatient').curPatient.id
        },{
            name: "appointmentDate",
            operator: "=",
            value: appointment.normalizedDate
        }];
        localStorageEngine.getDataSource('/AnthAvaliationResults', filterPatient).then(function(anthResults) {
            historyAvaliations.results = anthResults;
        }).then(function(){
            var methodAndResult = [];

            var getResultsByMethod = function(m){
                return methodAndResult.findIndex(function(metodo){
                    return metodo.idMetodo === m.idMetodo;
                });
            };
            
            historyAvaliations.results.forEach(function(result){
                var index = getResultsByMethod(result);
                if(index !== -1){
                    methodAndResult[index].resultados.push(result);
                }else{
                    var metodoToResult = {
                        'idMetodo': result.idMetodo,
                        'nomeMetodo': result.nomeMetodo,
                        'dataAval': result.anthDate,
                        'resultados': [result]
                    };
                    methodAndResult.push(metodoToResult);
                }
            });
            historyAvaliations.methodAndResult = methodAndResult;
            historyAvaliations.appointmentDate = appointment.normalizedDate;
            historyAvaliations.methods = historyAvaliations.container.getWidget('WidgetDetailsPatient').antrLoadedFields;
            historyAvaliations.isVisible = true;
        });
        
    };
    
    this.closePopup = function(historyAvaliations){
        historyAvaliations.isVisible = false;
    };
    this.clique = function (id) {
        var itemList = $(".resultados_"+id);
        var arrow = $("#rotate_"+id);
        if(itemList.hasClass('panel-history')){
            itemList.removeClass('panel-history');
            itemList.addClass('antro-result-row');
        }else{
            itemList.addClass('panel-history');
            itemList.removeClass('antro-result-row');
        }
        arrow.hasClass('rotate') ? arrow.removeClass('rotate') : arrow.addClass('rotate');
    };
}